(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



modelversion = 5.1; modelcomment = "GEO-style quad pendulum with massless blades with z and x DOFs";


modelversion::usage = "modelversion is a number specifying the version of the default model."; 
modelcomment::usage = "modelcomment is a string describing the default model.";


Off[General::spell,General::spell1]


If[$VersionNumber<6., Needs["Graphics`Graphics`"]]


If[$VersionNumber<6., Needs["Graphics`Shapes`"]];


If[$VersionNumber<6., Needs["Graphics`Polyhedra`"]]


Needs::ignorethestupidwarning = "The following warning message about an obsolete package is harmless.";


If[$VersionNumber>=6.&&(!MemberQ[$Packages,"LinearAlgebra`MatrixManipulation`"]), 
	Message[Needs::ignorethestupidwarning]
];


Needs["LinearAlgebra`MatrixManipulation`"]


Needs["RotationsXYZ`"]


Needs["StatusWindow`"];


Needs["MatlabExport`"];


Needs["IFOModel`"];


Needs["PendUtil`"];


If[utilitiesversion>=3.0,Null, Print["Incorrect utilities version"];Abort[],Print["Utilities failed to load"];Abort[]];


allvars::usage = "allvars is part of the specification of the model. It should be a list of the position and angle variables for the system. It shouldn't include velocities, or the coordinates of the support structure.";


allvars = {
	x0,y0,z0,yaw0,pitch0,roll0,
	x1,y1,z1,yaw1,pitch1,roll1,
	x2,y2,z2,yaw2,pitch2,roll2,
	x3,y3,z3,yaw3,pitch3,roll3
};


longpitchvars = {
	x0,pitch0,
	x1,pitch1,
	x2,pitch2,
	x3,pitch3
};
longpitchvarsM = {
	pitch0,x0,
	pitch1,x1,
	pitch2,x2,
	pitch3,x3
};
transrollvars = {
	y0,roll0,
	y1,roll1,
	y2,roll2,
	y3,roll3
};
transrollvarsM = {
	roll0,y0,
	roll1,y1,
	roll2,y2,
	roll3,y3
};
yawvars = {
	yaw0,
	yaw1,
	yaw2,
	yaw3
};
vertvars = {
	z0,
	z1,
	z2,
	z3
};


longpitchvels = {vx0,vpitch0,vx1,vpitch1,vx2,vpitch2,vx3,vpitch3};
longpitchvelsM = {vpitch0,vx0,vpitch1,vx1,vpitch2,vx2,vpitch3,vx3};
transrollvels = {vy0,vroll0,vy1,vroll1,vy2,vroll2,vy3,vroll3};
transrollvelsM = {vroll0,vy0,vroll1,vy1,vroll2,vy2,vroll3,vy3};
yawvels = {vyaw0,vyaw1,vyaw2,vyaw3};
vertvels = {vz0,vz1,vz2,vz3};


allfloats::usage = "allfloats is part of the specification of the model. It should be a list of the positions and angles of connections where one elastic element is connected directly to another with no mass element between.";


allfloats = {
	qzul,
	qxul,
	qzur,
	qxur,
	qzil,
	qxil,
	qzir,
	qxir,
	qzll,
	qxll,
	qzlr,
	qxlr,
	qqxulf, (* extra floats to represent upper neck ends *)
	qqyulf,
	qqzulf,
	qqxurf,
	qqyurf,
	qqzurf,
	qqxulb,
	qqyulb,
	qqzulb,
	qqxurb,
	qqyurb,
	qqzurb,
	qqxllf, (* extra floats to represent lower neck ends *)
	qqyllf,
	qqzllf,
	qqxlrf,
	qqylrf,
	qqzlrf,
	qqxllb,
	qqyllb,
	qqzllb,
	qqxlrb,
	qqylrb,
	qqzlrb
};


allparams::usage = "allparams is part of the specification of the model. It should be a list of the positions and angles describing the state of the support structure, plus any other coordinates that are constant for the purposes of the normal mode calculation but through which one might want to inject a displacement input.";


allparams = {
x00,y00,z00 ,yaw00,pitch00,roll00 
};


LCO = {0,0,0}; NOM::usage = "LCO is the local coordinate origin for any mass, {0,0,0}.";


COM = LCO; COM::usage = "COM (=LCO) is the centre of mass in local coordinates for blade tips and other objjects not having a custom definition.";


FRP = LCO; FRP::usage = "FRP (=LCO) is the default fixture reference point in local coordinates relative to which offsets to wire and spring attachment points are calculated. The pendulum masses have custom definitions, FRP1, FRP2 and FRP3.";


support={x00,y00,z00,yaw00,pitch00,roll00}; support::usage="support is a list of the parameters specifying the support structure.";


bladeUL = Join[b2s[support, {0, nn0, 0} + RotationMatrixXYZBS[0, pitchbul, rollbul] . {qxul, 0, qzul}], 
    support[[{4, 5, 6}]]]; 
bladeUL::usage = "bladeUL is a list of the variables specifying the upper left blade tip."; 
bladeUR = Join[b2s[support, {0, -nn0, 0} + RotationMatrixXYZBS[0, pitchbur, rollbur] . {qxur, 0, qzur}], 
    support[[{4, 5, 6}]]]; 
bladeUR::usage = "bladeUR is a list of the variables specifying the upper right blade tip."; 


bladeULnom={0,-nn0,0};
bladeULnom::usage = "bladeULnom is the nominal position of the upper left blade tip relative to the structure.";
bladeURnom={0,nn0,0};
bladeURnom::usage = "bladeURnom is the nominal position of the upper right blade tip relative to the structure.";


bladeULa = {0, 0, 0};
bladeULa::usage="bladeULa is the attachment point of the wire on the upper left blade tip.";
bladeURa = {0, 0, 0};
bladeURa::usage="bladeURa is the attachment point of the wire on the upper right blade tip.";


massN={x0,y0,z0,yaw0,pitch0,roll0};
massN::usage="massN is a list of the variables specifying the top mass (a.k.a., mass N).";


COM0={COM0x,COM0y,COM0z};
COM0::usage="COM0 is the COM of the top mass (a.k.a., mass N) in local coordinates.";


FRP0 = {FRP0x, FRP0y, FRP0z}; 
FRP0::usage = "FRP0 is the fixture reference point of the top mass (a.k.a., mass N) in local coordinates."; 


massNl=FRP0+{0,nn1,dm};
massNl::usage="massNl is the attachment point of the wire from the upper \
left blade spring at the top mass.";
massNr=FRP0+{0,-nn1,dm};
massNr::usage="massNr is the attachment point of the wire from the upper \
right blade spring at the top mass.";


bladeIL =Join[b2s[massN,{0,n0,-dn}+RotationMatrixXYZBS[0,pitchbil,rollbil].{qxil,0,qzil}],massN[[{4,5,6}]]];
bladeIL::usage="bladeIL is a list of the variables specifying the intermediate left blade tip.";
bladeIR=Join[b2s[massN,{0,-n0,-dn}+RotationMatrixXYZBS[0,pitchbir,rollbir].{qxir,0,qzir}],massN[[{4,5,6}]]];
bladeIR::usage="bladeIR is a list of the variables specifying the intermediate right blade tip.";
bladeILf =FRP+{-su,0,0};
bladeILf::usage="bladeILf is the front wire attachment point on the intermediate left blade tip.";
bladeILb = FRP+{su,0,0};
bladeILb::usage="bladeILb is the back wire attachment point on the intermediate left blade tip.";
bladeIRf = FRP+{-su,0,0};bladeIRf::usage="bladeIRf is the front wire attachment point on the intermediate right blade tip.";
bladeIRb =FRP+ {su,0,0};
bladeIRb::usage="bladeIRb is the back wire attachment point on the intermediate right blade tip.";


bladeILnom=FRP0+{0,n0,-dn};
bladeILnom::usage = "bladeILnom is the nominal position of the intermediate left blade tip relative to the top mass.";
bladeIRnom=FRP0+{0,-n0,-dn};
bladeIRnom::usage = "bladeIRnom is the nominal position of the intermediate right blade tip relative to the top mass.";


massU={x1,y1,z1,yaw1,pitch1,roll1};
massU::usage="massU is a list of the variables specifying the second top mass (a.k.a., mass U).";


COM1={COM1x,COM1y,COM1z};
COM1::usage="COM1 is the COM of the second mass (a.k.a., mass U) in local coordinates.";


FRP1={FRP1x,FRP1y,FRP1z};
FRP1::usage="FRP1 is the fixture reference point of the second mass (a.k.a., mass U) in local coordinates.";


massUlf=FRP1+{-su,n1,d0};
massUlf::usage="massUlf is the attachment point of the front wire from the intermediate \
left blade spring at the second top mass.";
massUlb=FRP1+{su,n1,d0};
massUlb::usage="massUlb is the attachment point of the back wire from the intermediate \
left blade spring at the second top mass.";
massUrf=FRP1+{-su,-n1,d0};
massUrf::usage="massUrf is the attachment point of the front wire from the intermediate \
right blade spring at the second top mass.";
massUrb=FRP1+{su,-n1,d0};
massUrb::usage="massUrb is the attachment point of the back wire from the intermediate \
right blade spring at the second top mass.";


bladeLL=Join[b2s[massU,{0,n2,-d1}+RotationMatrixXYZBS[0,pitchbll,rollbll].{qxll,0,qzll}],massU[[{4,5,6}]]];
bladeLL::usage="bladeLL is a list of the variables specifying the lower left blade tip.";
bladeLR=Join[b2s[massU,{0,-n2,-d1}+RotationMatrixXYZBS[0,pitchblr,rollblr].{qxlr,0,qzlr}],massU[[{4,5,6}]]];
bladeLR::usage="bladeLR is a list of the variables specifying the lower right blade tip.";
bladeLLf = FRP+{-si,0,0};
bladeLLf::usage="bladeLLf is the front wire attachment point on the lower left blade tip.";
bladeLLb = FRP+{si,0,0};
bladeLLb::usage="bladeLLb is the back wire attachment point on the lower left blade tip.";
bladeLRf = FRP+{-si,0,0};
bladeLRf::usage="bladeLRf is the front wire attachment point on the lower right blade tip.";
bladeLRb =FRP+ {si,0,0};
bladeLRb::usage="bladeLRb is the back wire attachment point on the lower right blade tip.";


bladeLLnom=FRP1+{0,n2,-d1};
bladeLLnom::usage = "bladeLLnom is the nominal position of the lower left blade tip relative to the second top mass.";
bladeLRnom=FRP1+{0,-n2,-d1};
bladeLRnom::usage = "bladeLRnom is the nominal position of the lower right blade tip relative to the second top mass.";


massI={x2,y2,z2,yaw2,pitch2,roll2};
massI::usage="massI is a list of the variables specifying the intermediate mass (a.k.a., mass I).";


COM2={COM2x,COM2y,COM2z};
COM2::usage="COM2 is the COM of the intermediate mass (a.k.a., mass I) in local coordinates.";


FRP2={FRP2x,FRP2y,FRP2z};
FRP2::usage="FRP2 is the fixture reference point of the intermediate mass (a.k.a., mass I) in local coordinates.";


massIulf=FRP2+{-si,n3,d2};
massIulf::usage="massIulf is the attachment point of the front wire from the lower \
left blade spring at the intermediate mass.";
massIulb=FRP2+{si,n3,d2};
massIulb::usage="massIulb is the attachment point of the back wire from the lower \
left blade spring at the intermediate mass.";
massIurf=FRP2+{-si,-n3,d2};
massIurf::usage="massIurf is the attachment point of the front wire from the lower \
right blade spring at the intermediate mass.";
massIurb=FRP2+{si,-n3,d2};
massIurb::usage="massIurb is the attachment point of the back wire from the lower \
right blade spring at the intermediate mass.";


massIllf=FRP2+{-sl,n4,-d3};
massIllf::usage="massIllf is the attachment point of the front left fibre at the intermediate mass.";
massIllb=FRP2+{sl,n4,-d3};
massIllb::usage="massIllb is the attachment point of the back left fibre at the intermediate mass.";
massIlrf=FRP2+{-sl,-n4,-d3};
massIlrf::usage="massIlrf is the attachment point of the front right fibre at the intermediate mass.";
massIlrb=FRP2+{sl,-n4,-d3};
massIlrb::usage="massIlrb is the attachment point of the back right fibre at the intermediate mass.";


nulf={qqxulf,qqyulf,qqzulf,0,0,0};
nulb={qqxulb,qqyulb,qqzulb,0,0,0};
nurf={qqxurf,qqyurf,qqzurf,0,0,0};
nurb={qqxurb,qqyurb,qqzurb,0,0,0};
nulf::usage="nulf is a list of the coordinates specifying the left front upper neck end.";
nulb::usage="nulb is a list of the coordinates specifying the left back upper neck end.";
nurf::usage="nurf is a list of the coordinates specifying the right front upper neck end.";
nurb::usage="nurb is a list of the coordinates specifying the right back upper neck end.";


nllf={qqxllf,qqyllf,qqzllf,0,0,0};
nllb={qqxllb,qqyllb,qqzllb,0,0,0};
nlrf={qqxlrf,qqylrf,qqzlrf,0,0,0};
nlrb={qqxlrb,qqylrb,qqzlrb,0,0,0};
nllf::usage="nllf is a list of the coordinates specifying the left front fibre lower neck end.";
nllb::usage="nllb is a list of the coordinates specifying the left back fibre lower neck end.";
nlrf::usage="nlrf is a list of the coordinates specifying the right front fibre lower neck end.";
nlrb::usage="nlrb is a list of the coordinates specifying the right back fibre lower neck end.";


optic={x3,y3,z3,yaw3,pitch3,roll3};
optic::usage="optic is a list of the variables specifying the optic.";


COM3={COM3x,COM3y,COM3z};
COM3::usage="COM3 is the COM of the optic in local coordinates.";


FRP3={FRP3x,FRP3y,FRP3z};
FRP3::usage="FRP3 is the fixture reference point of the optic in local coordinates.";


opticlf=FRP3+{-sl,n5,d4};
opticlf::usage="opticlf is the attachment point of the front left fibre at the optic.";
opticlb=FRP3+{sl,n5,d4};
opticlb::usage="opticlb is the attachment point of the back left fibre at the optic.";
opticrf=FRP3+{-sl,-n5,d4};
opticrf::usage="opticrf is the attachment point of the front right fibre at the optic.";
opticrb=FRP3+{sl,-n5,d4};
opticrb::usage="opticrb is the attachment point of the back right fibre at the optic.";


gravlist::usage = "gravlist is part of the specification of the model. It is a list of expressions for the gravitational potential energy of various objects. All the terms are taken implicitly to have damping of type gravtype.";


gravlist = {};
AppendTo[gravlist, mn g b2s[massN,COM0][[3]]];
AppendTo[gravlist, m1 g b2s[massU,COM1][[3]]];
AppendTo[gravlist, m2 g b2s[massI,COM2][[3]]];
AppendTo[gravlist, m3 g b2s[optic,COM3][[3]]];


wirelist::usage = "wirelist is part of the specification of the model. It is a list of structures defining wires. Each structure containing the following items:\n
{\n
	coordinate list defining first mass,\n
	attachment point for first mass (local coordinates),\n
	attachment vector for first mass,\n
	coordinate list defining second mass,\n
	attachment point for second mass (local coordinates),\n
	attachment vector for second mass,\n
	Young's modulus,\n
	unstretched length,\n
	longitudinal elasticity,\n
	vector defining principal axis 1,\n
	moment of area along principal axis 1,\n
	moment of area along principal axis 2,\n
	linear elasticity type,\n
	angular elasticity type\n
}";

	


wirelist={};


AppendTo[wirelist,{
	bladeUL,
	bladeULa, 
	bladeULavec,
	massN,
	massNl,
	massNlvec,
	Yn,
	uln,
	kwn,
	{1,0,0},
	Mn1,
	Mn2,
	wireUtype,
	wireUatype
}];


AppendTo[wirelist,{
	bladeUR,
	bladeURa, 
	bladeURavec,
	massN,
	massNr,
	massNrvec,
	Yn,
	uln,
	kwn,
	{1,0,0},
	Mn1,
	Mn2,
	wireUtype,
	wireUatype
}];


AppendTo[wirelist,{
	bladeIL,
	bladeILf, 
	bladeILfvec,
	massU,
	massUlf,
	massUlfvec,
	Y1,
	ul1,
	kw1,
	{1,0,0},
	M11,
	M12,
	wireItype,
	wireIatype
}];


AppendTo[wirelist,{
	bladeIR,
	bladeIRf, 
	bladeIRfvec,
	massU,
	massUrf,
	massUrfvec,
	Y1,
	ul1,
	kw1,
	{1,0,0},
	M11,
	M12,
	wireItype,
	wireIatype
}];


AppendTo[wirelist,{
	bladeIL,
	bladeILb, 
	bladeILbvec,
	massU,
	massUlb,
	massUlbvec,
	Y1,
	ul1,
	kw1,
	{1,0,0},
	M11,
	M12,
	wireItype,
	wireIatype
}];


AppendTo[wirelist,{
	bladeIR,
	bladeIRb, 
	bladeIRbvec,
	massU,
	massUrb,
	massUrbvec,
	Y1,
	ul1,
	kw1,
	{1,0,0},
	M11,
	M12,
	wireItype,
	wireIatype
}];


AppendTo[wirelist,{
	bladeLL,
	bladeLLf, 
	bladeLLfvec,
	massI,
	massIulf,
	massIulfvec,
	Y2,
	ul2,
	kw2,
	{1,0,0},
	M21,
	M22,
	wireLtype,
	wireLatype
}];


AppendTo[wirelist,{
	bladeLR,
	bladeLRf, 
	bladeLRfvec,
	massI,
	massIurf,
	massIurfvec,
	Y2,
	ul2,
	kw2,
	{1,0,0},
	M21,
	M22,
	wireLtype,
	wireLatype
}];


AppendTo[wirelist,{
	bladeLL,
	bladeLLb, 
	bladeLLbvec,
	massI,
	massIulb,
	massIulbvec,
	Y2,
	ul2,
	kw2,
	{1,0,0},
	M21,
	M22,
	wireLtype,
	wireLatype
}];


AppendTo[wirelist,{
	bladeLR,
	bladeLRb, 
	bladeLRbvec,
	massI,
	massIurb,
	massIurbvec,
	Y2,
	ul2,
	kw2,
	{1,0,0},
	M21,
	M22,
	wireLtype,
	wireLatype
}];


AppendTo[wirelist,{
	massI,
	massIllf, 
	massIllfvec,
	nulf,
	COM,
	0,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


AppendTo[wirelist,{
	massI,
	massIlrf,
	massIlrfvec,
	nurf,
	COM,
	0,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


AppendTo[wirelist,{
	massI,
	massIllb, 
	massIllbvec,
	nulb,
	COM,
	0,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


AppendTo[wirelist,{
	massI,
	massIlrb,
	massIlrbvec,
	nurb,
	COM,
	0,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


AppendTo[wirelist,{
	nulf,
	COM, 
	0,
	nllf,
	COM,
	0,
	Y3,
	ul3*(1-2*nf),
	kw3m,
	{1,0,0},
	10^-20, (* needs to be non-zero *)
	10^-20, (* needs to be non-zero *)
	fibretype,
	gravtype
}];


AppendTo[wirelist,{
	nurf,
	COM,
	0,
	nlrf,
	COM,
	0,
	Y3,
	ul3*(1-2*nf),
	kw3m,
	{1,0,0},
	10^-20, (* needs to be non-zero *)
	10^-20, (* needs to be non-zero *)
	fibretype,
	gravtype
}];


AppendTo[wirelist,{
	nulb,
	COM, 
	0,
	nllb,
	COM,
	0,
	Y3,
	ul3*(1-2*nf),
	kw3m,
	{1,0,0},
	10^-20, (* needs to be non-zero *)
	10^-20, (* needs to be non-zero *)
	fibretype,
	gravtype
}];


AppendTo[wirelist,{
	nurb,
	COM,
	0,
	nlrb,
	COM,
	0,
	Y3,
	ul3*(1-2*nf),
	kw3m,
	{1,0,0},
	10^-20, (* needs to be non-zero *)
	10^-20, (* needs to be non-zero *)
	fibretype,
	gravtype
}];


AppendTo[wirelist,{
	nllf,
	COM, 
	0,
	optic,
	opticlf,
	opticlfvec,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


AppendTo[wirelist,{
	nlrf,
	COM,
	0,
	optic,
	opticrf,
	opticrfvec,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


AppendTo[wirelist,{
	nllb,
	COM, 
	0,
	optic,
	opticlb,
	opticlbvec,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


AppendTo[wirelist,{
	nlrb,
	COM,
	0,
	optic,
	opticrb,
	opticrbvec,
	Y3,
	ul3*nf,
	kw3n,
	{1,0,0},
	M31,
	M32,
	fibretype,
	fibreatype
}];


springlist::usage = "springlist is part of the specification of the model. It is a list of structures defining springs. Each structure containing the following items:\n
{\n
	coordinate list defining first mass,\n
	attachment point for first mass (local coordinates),\n
	attachment angles for first mass (yaw, pitch, roll),\n
	coordinate list defining second mass,\n
	attachment point for second mass (local coordinates),\n
	attachment angles for second mass (yaw, pitch, roll),\n
	damping type,\n
	6x6 elasticity matrix,\n
	1*6 force vector\n
}";


springlist = {};


AppendTo[springlist, {
	support,
	bladeULnom,
	{0,pitchbul,rollbul},
	bladeUL,
	COM,
	{0,pitchbul,rollbul},
	bladeUtype,
	{
		{kbux,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kbuz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bdu*kbuz,0,0,0}
}];


AppendTo[springlist, {
	support,
	bladeURnom,
	{0,pitchbur,rollbur},
	bladeUR,
	COM,
	{0,pitchbur,rollbur},
	bladeUtype,
	{
		{kbux,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kbuz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bdu*kbuz,0,0,0}
}];


AppendTo[springlist, {
	massN,
	bladeILnom,
	{0,pitchbil,rollbil},
	bladeIL,
	COM,
	{0,pitchbil,rollbil},
	bladeItype,
	{
		{kbix,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kbiz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bdi*kbiz,0,0,0}
}];


AppendTo[springlist, {
	massN,
	bladeIRnom,
	{0,pitchbir,rollbir},
	bladeIR,
	COM,
	{0,pitchbir,rollbir},
	bladeItype,
	{
		{kbix,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kbiz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bdi*kbiz,0,0,0}
}];


AppendTo[springlist, {
	massU,
	bladeLLnom,
	{0,pitchbll,rollbll},
	bladeLL,
	COM,
	{0,pitchbll,rollbll},
	bladeLtype,
	{
		{kblx,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kblz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bdl*kblz,0,0,0}
}];


AppendTo[springlist, {
	massU,
	bladeLRnom,
	{0,pitchblr,rollblr},
	bladeLR,
	COM,
	{0,pitchblr,rollblr},
	bladeLtype,
	{
		{kblx,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,kblz,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0},
		{0,0,0,0,0,0}
	},
	{0,0,bdl*kblz,0,0,0}
}];


IBU = {
	{Ibtxu, Ibtxyu, Ibtzxu}, 
	{Ibtxyu, Ibtyu, Ibtyzu}, 
	{Ibtzxu, Ibtyzu, Ibtzu}
};	(* upper blade tip *)


IMN = {
	{Inx, Inxy, Inzx}, 
	{Inxy, Iny, Inyz}, 
	{Inzx, Inyz, Inz}
};	(* top mass *)


IBI = {
	{Ibtxi, Ibtxyi, Ibtzxi}, 
	{Ibtxyi, Ibtyi, Ibtyzi}, 
	{Ibtzxi, Ibtyzi, Ibtzi}
};	(* lower blade tip *)


IM1 = {
	{I1x, I1xy, I1zx}, 
	{I1xy, I1y, I1yz}, 
	{I1zx, I1yz, I1z}
};	(* second mass *)


IBL = {
	{Ibtxl, Ibtxyl, Ibtzxl}, 
	{Ibtxyl, Ibtyl, Ibtyzl}, 
	{Ibtzxl, Ibtyzl, Ibtzl}
};	(* lower blade tip *)


IM2 = {
	{I2x, I2xy, I2zx}, 
	{I2xy, I2y, I2yz}, 
	{I2zx, I2yz, I2z}
};	(* intermediate mass *)


IM3 = {
	{I3x, I3xy, I3zx}, 
	{I3xy, I3y, I3yz}, 
	{I3zx, I3yz, I3z}
};	(* optic *)


IBU::usage = "IBU is the MOI tensor for either of the upper blade tips.";
IMN::usage = "IMN is the MOI tensor for mass N.";
IBI::usage = "IBI is the MOI tensor for either of the intermediate blade tips.";
IM1::usage = "IM1 is the MOI tensor for mass U tips.";
IBL::usage = "IBL is the MOI tensor for either of the lower blade tips.";
IM2::usage = "IM2 is the MOI tensor for mass I.";
IM3::usage = "IM3 is the MOI tensor for the optic.";



kinetic::usage = "kinetic is part of the specification of the model. It should be an expression for the kinetic energy in terms of derivatives of the variables (e.g., Dt[x1,t]).";


kinetic = (
	+(1/2) mn Plus@@(Dt[b2s[massN,COM0],t]^2)
	+(1/2) omegaB[yaw0, pitch0, roll0].IMN.omegaB[yaw0, pitch0, roll0]

	+(1/2) m1 Plus@@(Dt[b2s[massU,COM1],t]^2) 
	+(1/2) omegaB[yaw1, pitch1, roll1].IM1.omegaB[yaw1, pitch1, roll1]

	+(1/2) m2 Plus@@(Dt[b2s[massI,COM2],t]^2)
	+(1/2) omegaB[yaw2, pitch2, roll2].IM2.omegaB[yaw2, pitch2, roll2]
	
	+(1/2) m3 Plus@@(Dt[b2s[optic,COM3],t]^2) 
	+(1/2) omegaB[yaw3, pitch3, roll3].IM3.omegaB[yaw3, pitch3, roll3]
);


defaultvalues::usage = "defaultvalues is part of the specification of the model. It should be a list of substitutions for all constants. Some of the values can be given symbolically in terms of other constants in the list, but there should be enough given numerically that the whole collection becomes numeric when Recurse[] is applied.";


defaultvalues = {

 g		-> 9.81,

(* MASS (N) is REPRESENTED by a rectangular BLOCK *)

(* in reality it will be larger and less dense. *)

 nx	-> 0.130,			(* dimensions of MASS (N) (square) *)

 ny	-> 0.500,

 nz	-> 0.084,

 denn	-> 4000.,			(* density (steel with holes) *)

 mn	-> 17.6246 (*denn* ny* nz* nx*),		(* MASS (N)  *)

 Inx	->  0.1640 (* mn*( ny^2+ nz^2)/12 *),	(* moment of inertia (transverse roll) *)

 Iny	->  0.0483 (* mn*( nz^2+ nx^2)/12 *),	(* moment of inertia (longitudinal pitch) *)

 Inz	->  0.1594 (* mn*( ny^2+ nx^2)/12 *),	(* moment of inertia (yaw) *)



(* ******************************************************************** *)

(* MASS (1) is REPRESENTED by a rectangular BLOCK *)

(* in reality it will be larger and less dense. *)



 ux	-> 0.130,			(* dimensions MASS (1) (square) *)

 uy 	-> 0.500,

 uz	-> 0.084,

 den1	-> 4000,			(* density (steel with holes) *)



 m1	-> 16.3747 (* den1* uy* uz* ux *),	(* MASS (1)  *)

	

 I1x	->  0.1302 (* m1*( uy^2+ uz^2)/12 *),	(* moment of inertia (transverse roll) *)

 I1y	->  0.0460 (* m1*( uz^2+ ux^2)/12 *),	(* moment of inertia (longitudinal pitch) *)

 I1z	->  0.1255 (* m1*( uy^2+ ux^2)/12 *),	(* moment of inertia (yaw) *)



(* ******************************************************************** *)

 ix	-> 0.12,			(* dimension of MASS (2) (cylinder) *)

 ir	-> 0.14,

 den2 -> 2200., (* fused silica *)

 m2	-> 16.24 (* den2*N[Pi]* ir^2* ix *),		(* MASS (2) *)



 I2x	-> 0.1880 (* m2*(ir^2/2) *),				(* moment of inertia (transverse roll) *)

 I2y	-> 0.11393 (* m2*(ir^2/4+ix^2/12) *),	(* moment of inertia (longitudinal pitch) *)

 I2z	-> 0.1130 (* m2*(ir^2/4+ix^2/12) *),	(* moment of inertia (yaw) *)



(* ********************************************************************* *)

 tx		-> 0.12,			(* dimensions of MASS (3) (cylinder) *)

 tr		-> 0.14,

 den3	-> 4000.,			(* density (sapphire) *)



 m3		-> 28.41 (* den3*N[Pi]*tr^2*tx *),	(* MASS (3) *)



 I3x	-> 0.2818 (* m3*(tr^2/2) *),				(* moment of inertia (transverse roll) *)

 I3y	-> 0.1664 (* m3*(tr^2/4+tx^2/12) *),	(* moment of inertia (longitudinal pitch) *)

 I3z	-> 0.1664 (* m3*(tr^2/4+tx^2/12) *),	(* moment of inertia (yaw) *)



(* ******************************************************************** *)

(* NOTE: These lengths were interpreted as stretched lengths in the Matlab. They are
  now consistently interpreted as either stretched or unstretched lengths depending 
  on the value of the switch constant unstretched. 
*)

ln -> 0.54,    	(* wire length 1: short version *)

l1	-> 0.304,		(* wire length 2: short version *)

l2	-> 0.302,		(* wire length 3: short version *)

l3	-> 0.6,	    	(* wire length 4 *)



 

(* ****************************************************************************************** *)

 nwn	-> 2, (* number of wires (-> number of cantilevers if fitted) per stage (2 or 4) *)

 nw1	-> 4,			

 nw2	-> 4,

 nw3	-> 4,



(* *********************************************************************************** *)

 rn	-> 400.*10^-6,	(* radius of wire (N) *)

 r1	-> 280.*10^-6,	(* radius of wire (1) *)

 r2	-> 280.*10^-6,	(* radius of wire (2)  *)

 r3n	-> 180.*10^-6,	(* radius of wire (3) *)
 r3m	-> 180.*10^-6,	(* radius of wire (3) *)



(* ************************************************************************************ *)

 Yn -> 1.65*10^11,	(* Youngs Modulus of wire	(N)	(s/steel 302) *) 

 Y1	-> 1.65*10^11,	(* Youngs Modulus of wire	(1)	(s/steel 302) *)

 Y2	-> 1.65*10^11,	(* Youngs Modulus of wire (2)	(s/steel 302) *) 

 Y3	-> 1.65*10^11,		(* Youngs Modulus of wire	(3)	(s/steel 302) *)

 

 (* blade design *)
 
 bladealpha -> 1.58,
 bladeY -> 186*10^9,
 hmin -> 0.001,
 hinc-> 0.0005,
 hsteps -> 12,
 wmin -> 0.03,
 wsteps ->18,

 mntb -> (mn+m1+m2+m3)/2,(* total per blade *)

 mnb  -> mn/2,(* uncoupled mass *)
 
smaxn -> 9*10^8,
lmaxn -> 0.55,
wmaxn -> 0.1,

ufcn -> opt[mnb,mntb,smaxn,lmaxn,wmaxn,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,1],
lnb -> opt[mnb,mntb,smaxn,lmaxn,wmaxn,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,2],
anb -> opt[mnb,mntb,smaxn,lmaxn,wmaxn,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,3],
hnb -> opt[mnb,mntb,smaxn,lmaxn,wmaxn,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,4],
stn -> opt[mnb,mntb,smaxn,lmaxn,wmaxn,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,5],

 intmoden -> 55*hnb*0.37^2/(0.002*lnb^2), (* scaled from GEO blade *)


 (* blade design *)

 m1tb -> (m1+m2+m3)/2,(* total per blade *)

 m1b  -> m1/2,(* uncoupled mass *)

smax1 -> 8.5*10^8,
lmax1 -> 0.42,
wmax1 -> 0.055,

ufc1  -> opt[m1b,m1tb,smax1,lmax1,wmax1,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,1],
l1b -> opt[m1b,m1tb,smax1,lmax1,wmax1,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,2],
a1b -> opt[m1b,m1tb,smax1,lmax1,wmax1,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,3],
h1b -> opt[m1b,m1tb,smax1,lmax1,wmax1,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,4],
st1 -> opt[m1b,m1tb,smax1,lmax1,wmax1,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,5],

 intmode1 -> 55*h1b*0.37^2/(0.002*l1b^2), (* scaled from GEO blade *)

(* blade design *)

 m2tb -> (m2+m3)/2, (* total per blade *)

 m2b  -> m2/2, (* uncoupled mass *)

smax2 -> 8.*10^8,
lmax2 -> 0.34,
wmax2 -> 0.044,

ufc2  -> opt[m2b,m2tb,smax2,lmax2,wmax2,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,1],
l2b -> opt[m2b,m2tb,smax2,lmax2,wmax2,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,2],
a2b -> opt[m2b,m2tb,smax2,lmax2,wmax2,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,3],
h2b -> opt[m2b,m2tb,smax2,lmax2,wmax2,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,4],
st2 -> opt[m2b,m2tb,smax2,lmax2,wmax2,g,bladealpha,bladeY,hmin,hinc,hsteps,wmin,wsteps,5],

 intmode2 -> 55*h2b*0.37^2/(0.002*l2b^2), (* scaled from GEO blade *)



(* ***************************************************************************************** *)

dees -> 0.001,

dm		-> 0.001,	(* height of wire break-off above c.of m. mass (N) *)

dn		-> 0.001,	(* height of wire break-off below c.of m. mass (N) *)

d0		-> 0.001,	(* height of wire break-off above c.of m. mass (1) *)

d1		-> 0.001,	(* height of wire break-off below c.of m. mass (1) *)

d2		-> -0.001,	(* height of wire break-off above c.of m. mass (2) *)

d3		-> 0.008,	(* height of wire break-off below c.of m. mass (2) *)

d4		-> 0.001,	(* height of wire break-off above c.of m. mass (3) *)

(* additional information for ribbon breakoffs *)

(* these are needed in translation/roll mode calculations *)

twistlength -> 0., (* length of twist section in ribbon *)

d3tr -> d3 - twistlength,

d4tr -> d4 - twistlength,

(* ****************************************************************************************** *)

(* X direction separation  *)

sn	-> 0.00,		(* 1/2 separation of wires (N)   *)

su	-> 0.0025,		(* 1/2 separation of wires (1)   *)

si	-> 0.0025,		(* 1/2 separation of wires (2)   *)

sl	-> 0.007,		(* 1/2 separation of wires (3)    *)



(* ****************************************************************************************** *)

(* Y direction separation *)

nn0 -> 0.25,   	(* 1/2 separation of wires (N) at suspension point *)

nn1 -> 0.05,   	(* 1/2 separation of wires (N) at mass (N)   *)

n0	-> 0.2,		(* 1/2 separation of wires (1) at mass (N)   *)

n1 -> 0.07,

n2 -> 0.12,

n3	->ir+0.0065,	(* 1/2 separation of wires (2) at mass (2)   *)

n4	->tr+0.0015,	(* 1/2 separation of wires (3) at mass (2)   *)

n5	->tr+0.0015,	(* 1/2 separation of wires (3) at mass (3)   *)



(* true lengths vertically from attachment point to attactment point etc. *)
(* NOTE this section has been adjusted to remove ambiguity - stretched lengths have been used throughout *)

tln -> Sqrt[sln^2 - (nn0-nn1)^2]+dm,

tl1 -> Sqrt[sl1^2 - (n0-n1)^2]+dn+d0,

tl2 -> Sqrt[sl2^2 - (n2-n3)^2]+d1+d2,

tl3 -> Sqrt[sl3^2 - (n4-n5)^2]+d3+d4,

ltotal  ->  tln +tl1+tl2+tl3,

(* *********************************************************************************** *)

(*  represents small loss *)

bd -> 0.00, (*  makes phases of open loop plots look nicer *)

leverpitch -> 0.06,

leverroll -> 0.09,

leveryaw -> 0.09,

gainf->1,
gain->6/gainf,
gainvpr->gain,
gainlty->gain,
gainpitch->gainvpr,
gainroll->1.4*gainvpr/3.,
gainyaw->1.*gainlty,
gainvertical->2.*gainvpr/3.,
gainlongitudinal->gainlty,
gaintransverse->2.*gainlty,


(* *********** END OF STUFF COPIED FROM QUADOPT.M **************************************** *)

unstretched -> False, (* switch specifying whether ln...l3 are interpreted as unstretched lengths or stretched lengths *)

vertblades->True, (* switch specifiying whether the blades act vertically or at right angles to wires *)

matlabcompat->False, (* switch for certain fudges to simulate GEO Matlab model *) 

uln->If[unstretched,ln,ln-(mn+m1+m2+m3)*g/(nwn*kwn*Cos[ArcSin[(nn0-nn1)/ln]])],
ul1->If[unstretched,l1,l1-(m1+m2+m3)*g/(nw1*kw1*Cos[ArcSin[(n0-n1)/l1]])],
ul2->If[unstretched,l2,l2-(m2+m3)*g/(nw2*kw2*Cos[ArcSin[(n2-n3)/l2]])],
ul3->If[unstretched,l3,l3-m3*g/(nw3*kw3*Cos[ArcSin[(n4-n5)/l3]])],

sln->If[unstretched,ln+(mn+m1+m2+m3)*g/(nwn*kwn*Cos[ArcTan[(nn0-nn1)/ln]]),ln],
sl1->If[unstretched,l1+(m1+m2+m3)*g/(nw1*kw1*Cos[ArcTan[(n0-n1)/l1]]),l1],
sl2->If[unstretched,l2+(m2+m3)*g/(nw2*kw2*Cos[ArcTan[(n2-n3)/l2]]),l2],
sl3->If[unstretched,l3+m3*g/(nw3*kw3*Cos[ArcTan[(n4-n5)/l3]]),l3],

sin->(nn1-nn0)/sln,
si1->(n1-n0)/sl1,
si2->(n3-n2)/sl2,
si3->(n5-n4)/sl3,
cn->Sqrt[sln^2-(nn1-nn0)^2]/sln,
c1->Sqrt[sl1^2-(n1-n0)^2]/sl1,
c2->Sqrt[sl2^2-(n3-n2)^2]/sl2,
c3->Sqrt[sl3^2-(n5-n4)^2]/sl3,

pitchbul->0,  (* pitch mounting angle of upper left blade spring *)
pitchbur->0,  (* pitch mounting angle of upper right blade spring *)
pitchbil->0,  (* pitch mounting angle of intermediate left blade spring *)
pitchbir->0,  (* pitch mounting angle of intermediate right blade spring *)
pitchbll->0,  (* pitch mounting angle of lower left blade spring *)
pitchblr->0,  (* pitch mounting angle of lower right blade spring *)
rollbul->If[vertblades,0,-ArcSin[sin]],  (* roll mounting angle of upper left blade spring *)
rollbur->If[vertblades,0,ArcSin[sin]],  (* roll mounting angle of upper right blade spring *)
rollbil->If[vertblades,0,-ArcSin[si1]],  (* roll mounting angle of intermediate left blade spring *)
rollbir->If[vertblades,0,ArcSin[si1]],  (* roll mounting angle of intermediate right blade spring *)
rollbll->If[vertblades,0,-ArcSin[si2]],  (* roll mounting angle of lower left blade spring *)
rollblr->If[vertblades,0,ArcSin[si2]],  (* roll mounting angle of lower right blade spring *)

An->N[Pi]*rn^2, (* effective average cross-sectional area of top wires *)
A1->N[Pi]*r1^2, (* effective average cross-sectional area of second wires *)
A2->N[Pi]*r2^2, (* effective average cross-sectional area of third wires *)
A3n->N[Pi]*r3n^2, (* effective average cross-sectional area of fibre necks *)
A3m->N[Pi]*r3m^2, (* effective average cross-sectional area of fibre midsections *)

nf -> 0.1,
kwn->Yn*An/ln, (* net longitudinal elasticity of top wires *) 
kw1->Y1*A1/l1, (* net longitudinal elasticity of second wires *) 
kw2->Y2*A2/l2, (* net longitudinal elasticity of third wires *) 
kw3->1/(1/kw3m+2/kw3n), (* net longitudinal elasticity of fibres *)
kw3n->Y3*A3n/(nf*l3), (* net longitudinal elasticity of one fibre neck *)
kw3m->Y3*A3m/((1-2*nf)*l3), (* net longitudinal elasticity of fibre midsection *)

kbuz->mnb*(2*N[Pi]*ufcn)^2, (* net elasticity of upper blade *) 
kbiz->m1b*(2*N[Pi]*ufc1)^2, (* net elasticity of middle blade *) 
kblz->m2b*(2*N[Pi]*ufc2)^2, (* net elasticity of lower blade *)

kbux->10000*kbuz,
kbix->10000*kbiz,
kblx->10000*kblz,

bdu->If[vertblades,1,1/cn]*(mn/2+m1/2+m2/2+m3/2)*g/kbuz, (* effective initial upper blade deformation *)
bdi->If[vertblades,1,1/c1]*(m1/2+m2/2+m3/2)*g/kbiz, (* effective initial middle blade deformation *)
bdl->If[vertblades,1,1/c2]*(m2/2+m3/2)*g/kblz,  (* effective initial lower blade deformation *)

Inxy -> 0,
Inyz -> 0,
Inzx -> 0,
COM0x -> 0,
COM0y -> 0,
COM0z -> 0,
FRP0x -> 0,
FRP0y -> 0,
FRP0z -> 0,
I1xy -> 0,
I1yz -> 0,
I1zx -> 0,
COM1x -> 0,
COM1y -> 0,
COM1z -> 0,
FRP1x -> 0,
FRP1y -> 0,
FRP1z -> 0,
I2xy -> 0,
I2yz -> 0,
I2zx -> 0,
COM2x -> 0,
COM2y -> 0,
COM2z -> 0,
FRP2x -> 0,
FRP2y -> 0,
FRP2z -> 0,
I3xy -> 0,
I3yz -> 0,
I3zx -> 0,
COM3x -> 0,
COM3y -> 0,
COM3z -> 0,
FRP3x -> 0,
FRP3y -> 0,
FRP3z -> 0,

btx->0.03,		(* display size of blade tip *)
bty->0.03,		(* display size of blade tip *)
btz->0.03,		(* display size of blade tip *)

Mn1-> (1/4) N[Pi] rn^4, (* moment of area of wire n in direction "1" *)
Mn2-> (1/4) N[Pi] rn^4, (* moment of area of wire n in direction "2" *)
M11-> (1/4) N[Pi] r1^4, (* moment of area of wire 1 in direction "1" *)
M12-> (1/4) N[Pi] r1^4, (* moment of area of wire 1 in direction "2" *)
M21-> (1/4) N[Pi] r2^4, (* moment of area of wire 2 in direction "1" *)
M22-> (1/4) N[Pi] r2^4, (* moment of area of wire 2 in direction "2" *)
M31-> (1/4) N[Pi] r3n^4, (* moment of area of wire 3 in direction "1" *)
M32-> (1/4) N[Pi] r3n^4, (* moment of area of wire 3 in direction "2" *)

(* damping stuff *)
temperature      -> ifo[Suspension,Temp],
boltzmann      -> ifo[Constants,kB],

alphasilica-> ifo[Suspension,Silica,Alpha],(* coeff. thermal expansion *)
betasilica-> 0.00015 (* ifo[Suspension,Silica,dlnEdT]*), (* temp. dependence Youngs modulus *)
rhosilica-> ifo[Suspension,Silica,Rho], (* mass density *)
Csilica-> ifo[Suspension,Silica,C], 
Ksilica-> ifo[Suspension,Silica,K],   (* W/(m kg)       *)
Ysilica    -> ifo[Suspension,Silica,Ey], 
phisilica->2. 10^-8,						(* intrinsic/bulk damping *)
phissilica->ifo[Suspension,Silica,Phi], (* surface damping, units of m *)

rhosteel  -> ifo[Suspension,C70Steel,Rho],
Csteel    -> ifo[Suspension,C70Steel,C],
Ksteel    -> ifo[Suspension,C70Steel,K],
Ysteel    -> ifo[Suspension,C70Steel,Ey], 
alphasteel  -> ifo[Suspension,C70Steel,Alpha], 
betasteel   -> ifo[Suspension,C70Steel,dlnEdT], 
phisteel -> ifo[Suspension,C70Steel,Phi], 

rhomarag   -> ifo[Suspension,MaragingSteel,Rho], 
Cmarag     -> ifo[Suspension,MaragingSteel,C], 
Kmarag     -> ifo[Suspension,MaragingSteel,K], 
Ymarag     -> ifo[Suspension,MaragingSteel,Ey],
alphamarag   -> ifo[Suspension,MaragingSteel,Alpha], 
betamarag    -> ifo[Suspension,MaragingSteel,dlnEdT], 
phimarag -> ifo[Suspension,MaragingSteel,Phi],
tmU    -> ifo[Suspension,Stage,4,Blade], (* ?????? *)
tmI    -> ifo[Suspension,Stage,3,Blade],  (* ?????? *)
tmL    -> ifo[Suspension,Stage,2,Blade],  (* ?????? *)

magicnumber->7.32 10^-2,
deltabladeU->Ymarag*alphamarag^2*temperature/(rhomarag*Cmarag), (* cf Bench delta_v1 *)
deltabladeI->Ymarag*alphamarag^2*temperature/(rhomarag*Cmarag), (* cf Bench delta_v2 *)
deltabladeL->Ymarag*alphamarag^2*temperature/(rhomarag*Cmarag), (* cf Bench delta_v3 *)
deltawireU->Ysteel*temperature*(alphasteel-betasteel*g*(mn+m1+m2+m3)/(nwn*N[Pi]*rn^2*Ysteel))^2/(rhosteel*Csteel), (* cf Bench delta_h1 *)
deltawireI->Ysteel*temperature*(alphasteel-betasteel*g*(m1+m2+m3)/(nw1*N[Pi]*r1^2*Ysteel))^2/(rhosteel*Csteel), (* cf Bench delta_h2 *)
deltawireL->Ysteel*temperature*(alphasteel-betasteel*g*(m2+m3)/(nw2*N[Pi]*r2^2*Ysteel))^2/(rhosteel*Csteel), (* cf Bench delta_h3 *)
deltafibre->Ysteel*temperature*(alphasteel-betasteel*g*(m3)/(nw3*N[Pi]*r3n^2*Ysteel))^2/(rhosteel*Csteel), 
(* deltafibre->Ysilica*temperature*(alphasilica-betasilica*g*(m3)/(nw3*N[Pi]*r3n^2*Ysilica))^2/(rhosilica*Csilica), *)
taubladeU->rhomarag*Cmarag*tmU^2/(Kmarag*N[Pi]^2),
taubladeI->rhomarag*Cmarag*tmI^2/(Kmarag*N[Pi]^2),
taubladeL->rhomarag*Cmarag*tmL^2/(Kmarag*N[Pi]^2),
tauwireU->magicnumber*rhosteel*Csteel*(2*rn)^2/Ksteel, (* cf Bench tau_steel1 *)
tauwireI->magicnumber*rhosteel*Csteel*(2*r1)^2/Ksteel, (* cf Bench tau_steel2 *)
tauwireL->magicnumber*rhosteel*Csteel*(2*r2)^2/Ksteel, (* cf Bench tau_steel3 *)
taufibre->magicnumber*rhosteel*Csteel*(2*r3n)^2/Ksteel, 
(*taufibre->magicnumber*rhosilica*Csilica*4*(N[Pi]*r3n^2)/N[Pi],*) (* cf Bench tau_si *)
damping[imag,bladeUtype] -> ((phimarag + deltabladeU*(2*N[Pi]*#1*taubladeU)/(1+(2*N[Pi]*#1*taubladeU)^2))&),
damping[imag,bladeItype] -> ((phimarag + deltabladeI*(2*N[Pi]*#1*taubladeI)/(1+(2*N[Pi]*#1*taubladeI)^2))&),
damping[imag,bladeLtype] -> ((phimarag + deltabladeL*(2*N[Pi]*#1*taubladeL)/(1+(2*N[Pi]*#1*taubladeL)^2))&),
damping[imag,wireUtype] -> (phisteel&),
damping[imag,wireItype] -> (phisteel&),
damping[imag,wireLtype] -> (phisteel&),
damping[imag,wireUatype] -> ((phisteel + deltawireU*(2*N[Pi]*#1*tauwireU)/(1+(2*N[Pi]*#1*tauwireU)^2))&),
damping[imag,wireIatype] -> ((phisteel + deltawireI*(2*N[Pi]*#1*tauwireI)/(1+(2*N[Pi]*#1*tauwireI)^2))&),
damping[imag,wireLatype] -> ((phisteel + deltawireL*(2*N[Pi]*#1*tauwireL)/(1+(2*N[Pi]*#1*tauwireL)^2))&),
damping[imag,fibretype] -> (phisteel&), (* ((phisilica + phissilica/r3n/2)&) *)
damping[imag,fibreatype] -> ((phisteel + deltafibre*(2*N[Pi]*#1*taufibre)/(1+(2*N[Pi]*#1*taufibre)^2))&), 
(* ((phisilica + phissilica/r3n + deltafibre*(2*N[Pi]*#1*taufibre)/(1+(2*N[Pi]*#1*taufibre)^2))&) *)
x00->0,
y00->0,
z00->0,
yaw00->0,
pitch00->0,
roll00->0,
constraintsubstitutions[] (* generates and splices in substitutions of form kconx1->0 *)
};


g::usage = "g is local gravity.";

nx::usage = "nx is x size of top mass (mass N).";	
ny::usage = "ny is y size of top mass (mass N).";	
nz::usage = "nz is z size of top mass (mass N).";	
denn::usage = "denn is density of top mass (mass N).";
mn::usage = "mn is mass of top mass (mass N).";
Inx::usage = "Inx is x-axis MOI of top mass (mass N).";
Iny::usage = "Iny is y-axis MOI of top mass (mass N).";
Inz::usage = "Inz is z-axis MOI of top mass (mass N).";

ux::usage = "ux is x size of second top mass (mass U).";	
uy::usage = "uy is y size of second top mass (mass U).";	
uz::usage = "uz is z size of second top mass (mass U).";	
den1::usage = "den1 is density of second top mass (mass U).";
m1::usage = "m1 is mass of second top mass (mass U).";
I1x::usage = "I1x is x-axis MOI of second top mass (mass U).";
I1y::usage = "I1y is y-axis MOI of second top mass (mass U).";
I1z::usage = "I1z is z-axis MOI of second top mass (mass U).";

ix::usage = "ix is thickness of intermediate mass (mass I).";	
ir::usage = "iy is radius of intermediate mass (mass I).";	
den2::usage = "den2 is density of intermediate mass (mass I).";
m2::usage = "m2 is mass of intermediate mass (mass I).";
I2x::usage = "I2x is x-axis MOI of intermediate mass (mass I).";
I2y::usage = "I2y is y-axis MOI of intermediate mass (mass I).";
I2z::usage = "I2z is z-axis MOI of intermediate mass (mass I).";

tx::usage = "ux is thickness of optic.";	
tr::usage = "uy is radius of optic.";	
den3::usage = "den3 is density of optic.";
m3::usage = "m3 is mass of optic.";
I3x::usage = "I3x is x-axis MOI of optic.";
I3y::usage = "I3y is y-axis MOI of optic.";
I3z::usage = "I3z is z-axis MOI of optic.";

unstretched::usage = "unstretched is a switch that specifies whether ln, l1, l2 and l3 are to be interpreted as unstretched lengths or (approximate) stretched lengths.";
kwfromunstretched::usage = "kwfromunstretched is a switch that specifies whether the net elasticities of the wires are to be computed using unstretched lengths or (approximate) stretched lengths.";

ln::usage = "ln is part of the specification of the model and represents the wire length from structure to top mass. It is interpreted as either a stretched length or an unstretched length depending on the value of the switch constant unstretched.";
l1::usage = "l1 is part of the specification of the model and represents the wire length from top mass to second top mass. It is interpreted as either a stretched length or an unstretched length depending on the value of the switch constant unstretched.";
l2::usage = "l2 is part of the specification of the model and represents the wire length from second top mass to intermediate mass. It is interpreted as either a stretched length or an unstretched length depending on the value of the switch constant unstretched.";
l3::usage = "l3 is part of the specification of the model and represents the wire (fibre) length from intermediate mass to optic. It is interpreted as either a stretched length or an unstretched length depending on the value of the switch constant unstretched.";

uln::usage = "uln is unstretched wire length from structure to top mass.";
ul1::usage = "ul1 is unstretched wire length from top mass to second top mass.";
ul2::usage = "ul2 is unstretched wire length from second top mass to intermediate mass.";
ul3::usage = "ul3 is unstretched wire (fibre) length from intermediate mass to optic.";

sln::usage = "sln is stretched wire length from structure to top mass.";
sl1::usage = "sl1 is stretched wire length from top mass to second top mass.";
sl2::usage = "sl2 is stretched wire length from second top mass to intermediate mass.";
sl3::usage = "sl3 is stretched wire (fibre) length from intermediate mass to optic.";

sin::usage = "sin is sine of angle of top wires.";
si1::usage = "si1 is sine of angle of second top wires.";
si2::usage = "si2 is sine of angle of bottom wires.";
si3::usage = "is sine of angle of fibres.";

cn::usage = "cn is cosine of angle of top wires.";
c1::usage = "c1 is cosine of angle of second top wires.";
c2::usage = "c2 is cosine of angle of bottom wires.";
c3::usage = "c3 is cosine of angle of fibres.";

nwn::usage = "nwn is number of wires from structure to top mass.";
nw1::usage = "nw1 is number of wires from top mass to second top mass.";
nw2::usage = "nw2 is number of wires from second top mass to intermediate mass.";
nw3::usage = "nw3 is number of wires (fibres) from intermediate mass to optic.";

rn::usage = "rn is radius of wires from structure to top mass.";
r1::usage = "r1 is radius of wires from top mass to second top mass.";
r2::usage = "r2 is radius of wires from second top mass to intermediate mass.";
r3n::usage = "r3n is radius of wires (fibres) necks from intermediate mass to optic.";
r3m::usage = "r3n is radius of wires (fibres) midsections from intermediate mass to optic.";

Yn::usage = "Yn is Young's modulus of wires from structure to top mass.";
Y1::usage = "Y1 is Young's modulus of wires from top mass to second top mass.";
Y2::usage = "Y2 is Young's modulus of wires from second top mass to intermediate mass.";
Y3::usage = "Y3 is Young's modulus of wires (fibres) from intermediate mass to optic.";

mntb::usage = "mntb is design load on upper blades (on structure).";
m1tb::usage = "m1tb is design load on intermediate blades (on top mass).";
m2tb::usage = "m2tb is design load on lower blades (on second top mass).";

mnb::usage = "mntb is the \"uncoupled mass\" (its share of the mass only one stage below) for the upper blades (on structure).";
m1b::usage = "m1tb is the \"uncoupled mass\" (its share of the mass only one stage below) for the intermediate blades (on top mass).";
m2b::usage = "m2tb is the \"uncoupled mass\" (its share of the mass only one stage below) for the lower blades (on second top mass).";

ufcn::usage = "ufcn is the \"uncoupled frequency\" (what they would vibrate at with only their \"uncoupled mass\", mnb) for the upper blades (on structure).";
ufc1::usage = "ufc1 is the \"uncoupled frequency\" (what they would vibrate at with only their \"uncoupled mass\", mn1) for the intermediate blades (on top mass).";
ufc2::usage = "ufc2 is the \"uncoupled frequency\" (what they would vibrate at with only their \"uncoupled mass\", mn2) for the lower blades (on second top mass).";

lnb::usage = "lnb is the length of the upper blades (on structure).";
l1b::usage = "l1b is the length of the the intermediate blades (on top mass).";
l2b::usage = "l2b is the length of the lower blades (on second top mass).";

anb::usage = "anb is the width (at the base) of the upper blades (on structure).";
a1b::usage = "a1b is the width (at the base) of the the intermediate blades (on top mass).";
a2b::usage = "a2b is the width (at the base) of the lower blades (on second top mass).";

hnb::usage = "hnb is the thickness of the upper blades (on structure).";
h1b::usage = "h1b is the thickness of the the intermediate blades (on top mass).";
h2b::usage = "h2b is the thickness of the lower blades (on second top mass).";

snb::usage = "snb is the (maximum?) strain in the upper blades (on structure).";
s1b::usage = "s1b is the (maximum?) strain in the intermediate blades (on top mass).";
s2b::usage = "s2b is the (maximum?) strain in the lower blades (on second top mass).";

intmoden::usage = "intmoden is the frequency of the internal mode of the upper blades (on structure).";
intmode1::usage = "intmode1 is the frequency of the internal mode of the intermediate blades (on top mass).";
intmode2::usage = "intmode2 is the frequency of the internal mode of the lower blades (on second top mass).";



(* ***************************************************************************************** *)

dees::usage = "dees is the default vertical distance from a wire attachment point to the COM.";
dm::usage = "dm is the height of the wire attachment points above the COM of mass N for the wires leading down from the upper blade springs.";
dn::usage = "dn is the height of the wire attachment points below the COM of mass N for the wires leading down to mass U.";
d0::usage = "d0 is the the height of the wire attachment points above the COM of mass U for the wires leading down from mass N.";
d1::usage = "d1 is the the height of the wire attachment points below the COM of mass U for the wires leading down to mass I.";
d2::usage = "d2 is the height of the wire attachment points above the COM of mass I for the wires leading down from the mass U.";
d3::usage = "d3 is the height of the wire attachment points below the COM of mass I for the wires leading down to the optic.";
d4::usage = "d4 is the the height of the wire attachment points above the COM of the optic for the wires leading down from mass I.";

twistlength::usage = "twistlength was left over from Ken Strain's model. It's not used and it's anybody's guess what it is.";
d3tr::usage = "d3tr was left over from Ken Strain's model. It's not used and it's anybody's guess what it is.";
d4tr::usage = "d4tr was left over from Ken Strain's model. It's not used and it's anybody's guess what it is.";

sn::usage = "sn is x-direction separation of wires from structure to top mass.";
su::usage = "su is x-direction separation of wires from top mass to second top mass.";
si::usage = "si is x-direction separation of wires from second top mass to intermediate mass.";
sl::usage = "sl is x-direction separation of wires (fibres) from intermediate mass to optic.";

nn0::usage = "nn0 is the y-direction separation of the wire attachment points on the structure for the wires leading down to mass N.";
nn1::usage = "nn1 is the y-direction separation of the wire attachment points on mass N for the wires leading from the structure.";
n0::usage = "n0 is the y-direction separation of the wire attachment points on the upper blade springs (mass N) for the wires leading down to mass U.";
n1::usage = "n1 is the y-direction separation of the wire attachment points on mass U for the wires leading down from the upper blade springs (mass N).";
n2::usage = "n2 is the y-direction separation of the wire attachment points on the intermediate blade springs (mass U) for the wires leading down to mass I.";
n3::usage = "n3 is the y-direction separation of the wire attachment points on mass I for the wires leading down from the intermediate blade springs (mass U).";
n4::usage = "n4 is the y-direction separation of the wire attachment points on mass I for the wires leading down to the optic.";
n5::usage = "n5 is the y-direction separation of the wire attachment points on the optic for the wires leading down from mass I.";

tln::usage = "tln is the vertical distance from structure attachment point to the COM of mass N.";
tl1::usage = "tl1 is the vertical distance from the COM of mass N to the COM of mass U.";
tl2::usage = "tl2 is the vertical distance from the COM of mass U to the COM of mass I.";
tl3::usage = "tl3 is the vertical distance from the COM of mass I to the COM of the optic.";

ltotal::usage = "ltotal is the vertical distance from the structure attachement point to the COM of the optic.";

bd::usage = "bd is a control system parameter which is currently not used in the Mathematica.";
leverroll::usage = "leverroll is a control system parameter which is currently not used in the Mathematica.";
leverpitch::usage = "leverpitch is a control system parameter which is currently not used in the Mathematica.";
leveryaw::usage = "leveryaw is a control system parameter which is currently not used in the Mathematica.";
gainf::usage = "gainf is a control system parameter which is currently not used in the Mathematica.";
gain::usage = "gain is a control system parameter which is currently not used in the Mathematica.";
gainvpr::usage = "gainvpr is a control system parameter which is currently not used in the Mathematica.";
gainlty::usage = "gainlty is a control system parameter which is currently not used in the Mathematica.";
gainpitch::usage = "gainpitch is a control system parameter which is currently not used in the Mathematica.";
gainroll::usage = "gainroll is a control system parameter which is currently not used in the Mathematica.";
gainyaw::usage = "gainyaw is a control system parameter which is currently not used in the Mathematica.";
gainvertical::usage = "gainvertical is a control system parameter which is currently not used in the Mathematica.";
gainlongitudinal::usage = "gainlongitudinal is a control system parameter which is currently not used in the Mathematica.";
gaintransverse::usage = "gaintransverse is a control system parameter which is currently not used in the Mathematica.";

An::usage = "An is effective average cross-sectional area of wires from structure to top mass for the purposes of calculating the longitudinal elasticity.";
A1::usage = "A1 is effective average cross-sectional area of wires from top mass to second top mass for the purposes of calculating the longitudinal elasticity.";
A2::usage = "A2 is effective average cross-sectional area of wires from second top mass to intermediate mass for the purposes of calculating the longitudinal elasticity.";
A3n::usage = "A3n is effective average cross-sectional area of wire (fibre) necks from intermediate mass to optic for the purposes of calculating the longitudinal elasticity.";
A3m::usage = "A3m is effective average cross-sectional area of wire (fibre) midsections from intermediate mass to optic for the purposes of calculating the longitudinal elasticity.";

kwn::usage = "kwn is net longitudinal elasticity of wires from structure to top mass.";
kw1::usage = "kw1 is net longitudinal elasticity of wires from top mass to second top mass.";
kw2::usage = "kw2 is net longitudinal elasticity of wires from second top mass to intermediate mass.";
kw3::usage = "kw3 is net longitudinal elasticity of wires (fibres) from intermediate mass to optic.";
kw3n::usage = "kw3n is net longitudinal elasticity of wire (fibre) neck.";
kw3m::usage = "kw3m is net longitudinal elasticity of wire (fibre) midsection.";

kbux::usage = "kbux is the net transverse elasticity of the upper blades (on structure).";
kbix::usage = "kbix is the net transverse elasticity of the the intermediate blades (on top mass).";
kblx::usage = "kblx is the net transverse elasticity of the lower blades (on second top mass).";

kbuy::usage = "kbuy is the net longitudinal elasticity of the upper blades (on structure).";
kbiy::usage = "kbiy is the net longitudinal elasticity of the the intermediate blades (on top mass).";
kbly::usage = "kbly is the net longitudinal elasticity of the lower blades (on second top mass).";

kbuz::usage = "kbuz is the net vertical elasticity of the upper blades (on structure).";
kbiz::usage = "kbiz is the net vertical elasticity of the the intermediate blades (on top mass).";
kblz::usage = "kblz is the net vertical elasticity of the lower blades (on second top mass).";

bdu::usage = "bdu is the effective pre-stretch distance of the upper blades (on structure).";
bdi::usage = "bdi is the effective pre-stretch distance of the intermediate blades (on top mass).";
bdl::usage = "bdl is the effective pre-stretch distance of the lower blades (on second top mass).";

kbyawu::usage = "kbyawu is the upper blade yaw stiffness";
kbpitchu::usage = "kbpitchu is the upper blade pitch stiffness";
kbrollu::usage = "kbrollu is the upper blade roll stiffness";  

kbyawi::usage = "kbyawi is the intermediate blade yaw stiffness";
kbpitchi::usage = "kbpitchi is the intermediate blade pitch stiffness";
kbrolli::usage = "kbrolli is the intermediate blade roll stiffness";

kbyawl::usage = " is the lower blade yaw stiffness";
kbpitchl::usage = " is the lower blade pitch stiffness";
kbrolll::usage = " is the lower blade roll stiffness";

Ibtxu::usage = "Ibtxu is the upper blade tip x MOI";
Ibtyu::usage = "Ibtyu is the upper blade tip y MOI";
Ibtzu::usage = "Ibtzu is the upper blade tip z MOI";
Ibtxi::usage = "Ibtxi is the intermediate blade tip x MOI";
Ibtyi::usage = "Ibtyi is the intermediate blade tip y MOI";
Ibtzi::usage = "Ibtzi is the intermediate blade tip z MOI";
Ibtxl::usage = "Ibtxl is the lower blade tip x MOI";
Ibtyl::usage = "Ibtyl is the lower blade tip y MOI";
Ibtzl::usage = "Ibtzl is the lower blade tip z MOI";

Ibtu::usage = "Ibtu is the MOI tensor of the objects representing the tips of the upper blades (on structure).";
Ibti::usage = "Ibti is the MOI tensor of the objects representing the tips of the intermediate blades (on top mass).";
Ibtl::usage = "Ibtl is the MOI tensor of the objects representing the tips of the lower blades (on second top mass).";

btx::usage = "btx is x-direction size of the box drawn to represent the blade tips.";
bty::usage = "bty is x-direction size of the box drawn to represent the blade tips.";
btz::usage = "btz is x-direction size of the box drawn to represent the blade tips.";

Mn1::usage = "Mn1 is the moment of area of wires from structure to top mass in direction \"1\".";
Mn2::usage = "Mn2 is the moment of area of wires from structure to top mass in direction \"2\".";
M11::usage = "M11 is the moment of area of wires from top mass to second top mass in direction \"1\".";
M12::usage = "M12 is the moment of area of wires from top mass to second top mass in direction \"2\"";
M21::usage = "M21 is the moment of area of wires from second top mass to intermediate mass in direction \"1\"";
M22::usage = "M22 is the moment of area of wires from second top mass to intermediate mass in direction \"2\"";
M31::usage = "M31 is the moment of area of wire (fibre) necks from intermediate mass to optic in direction \"1\"";
M32::usage = "M32 is the moment of area of wire (fibre) necks from intermediate mass to optic in direction \"2\"";

(* damping stuff *)

damping::usage = "damping[imag,dampingtype] is a multiplier giving the frequency dependence of the imaginary (i.e., lossy) part of any potential terms tagged with symbol dampingtype. It should be a Mathematica pure function which accepts a value of f in Hz. It defaults to 0& but can be given a value via a substitution in defaultvalues. damping[real,dampingtype] is the corresponding real (i.e., elastic) multiplier. It defaults to 1&.";

temperature::usage = "temperature is, well, guess.";

alphasilica::usage = "alphasilica is the coefficient of thermal expansion for silica.";
betasilica::usage = "betasilica is the temperature dependence of Young's modulus for silica.";
rhosilica::usage = "rhosilica is the density for silica.";
Csilica::usage = "Csilica is the heat capacity for silica.";
Ksilica::usage = "Ksilica is the bulk modulus for silica.";
Ysilica::usage = "Ysilica is the Young's modulus for silica.";
phisilica::usage = "phisilica is the bulk loss angle for silica.";
phissilica::usage = "phissilica is the surface loss angle (units of m) for silica.";

alphasteel::usage = "alphasteel is the coefficient of thermal expansion for C70 steel.";
betasteel::usage = "betasteel is the temperature dependence of Young's modulus for C70 steel.";
rhosteel::usage = "rhosteel is the density for C70 steel.";
Csteel::usage = "Csteel is the heat capacity for C70 steel.";
Ksteel::usage = "Ksteel is the bulk modulus for C70 steel.";
Ysteel::usage = "Ysteel is the Young's modulus for C70 steel.";
phisteel::usage = "phisteel is the bulk loss angle for C70 steel.";

alphamarag::usage = "alphamarag is the coefficient of thermal expansion for maraging steel.";
betamarag::usage = "betamarag is the temperature dependence of Young's modulus for maraging steel.";
rhomarag::usage = "rhomarag is the density for maraging steel.";
Cmarag::usage = "Cmarag is the heat capacity for maraging steel.";
Kmarag::usage = "Kmarag is the bulk modulus for maraging steel.";
Ymarag::usage = "Ymarag is the Young's modulus for maraging steel.";
phimarag::usage = "phimarag is the bulk loss angle for maraging steel.";

magicnumber::usage = "magicnumber is a geometrical factor for thermoelastic damping.";
deltabladeU::usage = "deltabladeU is the thermoelastic damping parameter delta for the upper blades.";
deltabladeI::usage = "deltabladeI is the thermoelastic damping parameter delta for the intermediate blades.";
deltabladeL::usage = "deltabladeL is the thermoelastic damping parameter delta for the lower blades.";
deltawireU::usage = "deltawireU is the thermoelastic damping parameter delta for the wires from the structure to mass N.";
deltawireI::usage = "deltawireI is the thermoelastic damping parameter delta for the wires from from mass N to mass U.";
deltawireL::usage = "deltawireL is the thermoelastic damping parameter delta for the wires from mass U to mass I.";
deltafibre::usage = "deltafibre is the thermoelastic damping parameter delta for the wires from mass I to the optic.";
taubladeU::usage = "taubladeU is the thermoelastic damping parameter tau for the upper blades.";
taubladeI::usage = "taubladeI is the thermoelastic damping parameter tau for the intermediate blades.";
taubladeL::usage = "taubladeL is the thermoelastic damping parameter tau for the lower blades.";
tauwireU::usage = "tauwireU is the thermoelastic damping parameter tau for the wires from the structure to mass N.";
tauwireI::usage = "tauwireI is the thermoelastic damping parameter tau for the wires from mass N to mass U.";
tauwireL::usage = "tauwireL is the thermoelastic damping parameter tau for the wires from mass U to mass I.";
taufibre::usage = "taufibre is the thermoelastic damping parameter tau for the wires from mass I to the optic.";


startpos::usage = "startpos is part of the specification of the model. It should be a list of approximate values of all variables to be used as a starting point for minimizing the potential. The values can be given symbolically in terms of constants defined in the list defaultvalues.";


startpos = {
	qzul->0,
	qxul->0,
	qzur->0,
	qxur->0,
	x0->-COM0x,
	y0->0,
	z0->z00-tln,
	yaw0->0,
	pitch0->0,
	roll0->0,
	qzil->0,
	qxil->0,
	qzir->0,
	qxir->0,
	yawir->0,
	pitchir->0,
	rollir->0,
	x1->-COM1x,
	y1->0,
	z1->z00-tln-tl1,
	yaw1->0,
	pitch1->0,
	roll1->0,
	qzll->0,
	qxll->0,
	qzlr->0,
	qxlr->0,
	x2->-COM2x,
	y2->0,
	z2->z00-tln-tl1-tl2,
	yaw2->0,
	pitch2->0,
	roll2->0,
	qqxulf->-sl, (* extra floats to represent upper neck ends *)
	qqyulf->n5,
	qqzulf->z00-tln-tl1-tl2-d3-nf*sl3,
	qqxurf->-sl,
	qqyurf->-n5,
	qqzurf->z00-tln-tl1-tl2-d3-nf*sl3,
	qqxulb->sl,
	qqyulb->n5,
	qqzulb->z00-tln-tl1-tl2-d3-nf*sl3,
	qqxurb->sl,
	qqyurb->-n5,
	qqzurb->z00-tln-tl1-tl2-d3-nf*sl3,
	
	qqxllf->-sl, (* extra floats to represent lower neck ends *)
	qqyllf->n5,
	qqzllf->z00-tln-tl1-tl2-d3-(1-nf)*sl3,
	qqxlrf->-sl,
	qqylrf->-n5,
	qqzlrf->z00-tln-tl1-tl2-d3-(1-nf)*sl3,
	qqxllb->sl,
	qqyllb->n5,
	qqzllb->z00-tln-tl1-tl2-d3-(1-nf)*sl3,
	qqxlrb->sl,
	qqylrb->-n5,
	qqzlrb->z00-tln-tl1-tl2-d3-(1-nf)*sl3,
	
	x3->-COM3x,
	y3->0,
	z3->z00-tln-tl1-tl2-tl3,
	yaw3->0,
	pitch3->0,
	roll3->0
};


lockedblades = Sequence@@{		
	kwnusual -> (Yn*An)/ln, 
	kw1usual -> (Y1*A1)/l1, 
	kw2usual -> (Y2*A2)/l2, 
	kw3usual -> (Y3*A3)/l3, 
	kbuzusual -> mnb*(2*N[Pi]*ufcn)^2, 
	kbizusual -> m1b*(2*N[Pi]*ufc1)^2, 
	kblzusual -> m2b*(2*N[Pi]*ufc2)^2, 
	kwn -> recipadd[kwnusual, kbuzusual], 
	kw1 -> recipadd[kw1usual, kbizusual/2], 
	kw2 -> recipadd[kw2usual, kblzusual/2], 
	kw3 -> kw3usual, 
	kbuz -> 10^5*kbuzusual, 
	kbiz -> 10^5*kbizusual, 
	kblz -> 10^5*kblzusual, 
	kbuy -> 10^5*kbuzusual, 
	kbiy -> 10^5*kbizusual, 
	kbly -> 10^5*kblzusual, 
	kbux -> 10^5*kbuzusual, 
	kbix -> 10^5*kbizusual, 
	kblx -> 10^5*kblzusual
};



lockedbladesLP = Sequence@@{		
	kbuzusual -> mnb*(2*N[Pi]*ufcn)^2, 
	kbizusual -> m1b*(2*N[Pi]*ufc1)^2, 
	kblzusual -> m2b*(2*N[Pi]*ufc2)^2, 
	kbuz -> 10^5*kbuzusual, 
	kbiz -> 10^5*kbizusual, 
	kblz -> 10^5*kblzusual, 
	kbuy -> 10^5*kbuzusual, 
	kbiy -> 10^5*kbizusual, 
	kbly -> 10^5*kblzusual, 
	kbux -> 10^5*kbuzusual, 
	kbix -> 10^5*kbizusual, 
	kblx -> 10^5*kblzusual
};



e2b::usage = "e2b is a matrix that applies omegaIB[] to all the the angular displacement elements of an eigenvector, converting them to body coordinates.";


e2b := DiagonalBlockMatrix[{
	IdentityMatrix[3],
	omegaIB[yaw0,pitch0,roll0],
	IdentityMatrix[3],
	omegaIB[yaw1,pitch1,roll1],
	IdentityMatrix[3],
	omegaIB[yaw2,pitch2,roll2],
	IdentityMatrix[3],
	omegaIB[yaw3,pitch3,roll3]
}]/.optval; 


e2s::usage = "e2s is a matrix that applies omegaIS[] to all the the angular displacement elements of an eigenvector, converting them to space coordinates.";


e2s := DiagonalBlockMatrix[{
	IdentityMatrix[3],
	omegaIS[yaw0,pitch0,roll0],
	IdentityMatrix[3],
	omegaIS[yaw1,pitch1,roll1],
	IdentityMatrix[3],
	omegaIS[yaw2,pitch2,roll2],
	IdentityMatrix[3],
	omegaIS[yaw3,pitch3,roll3]
}]/.optval; 


e2ni::usage = "e2ni is a matrix that applies omegaSNI[] to all the the angular displacement elements of an eigenvector, converting them to non-incremental yaw/pitch/roll format.";


e2ni := DiagonalBlockMatrix[{
	IdentityMatrix[3],
	omegaSNI.omegaIS[yaw0,pitch0,roll0],
	IdentityMatrix[3],
	omegaSNI.omegaIS[yaw1,pitch1,roll1],
	IdentityMatrix[3],
	omegaSNI.omegaIS[yaw2,pitch2,roll2],
	IdentityMatrix[3],
	omegaSNI.omegaIS[yaw3,pitch3,roll3]
}]/.optval; 


supportxinput = makeinputvector[x00];


supportxinput::usage = "supportxinput is a vector representing excitation of the support in x.";


supportyinput = makeinputvector[y00];


supportyinput::usage = "supportyinput is a vector representing excitation of the support in y.";


supportzinput = makeinputvector[z00];


supportzinput::usage = "supportzinput is a vector representing excitation of the support in z.";


supportyawinput = makeinputvector[yaw00];


supportyawinput::usage = "supportyawinput is a vector representing excitation of the support in yaw.";


supportpitchinput = makeinputvector[pitch00];


supportpitchinput::usage = "supportpitchinput is a vector representing excitation of the support in pitch.";


supportrollinput = makeinputvector[roll00];


supportrollinput::usage = "supportrollinput is a vector representing excitation of the support in roll.";


opticxoutput = makeoutputvector[x3];


opticyoutput = makeoutputvector[y3];


opticzoutput = makeoutputvector[z3];


opticyawoutput = makeoutputvector[yaw3];


opticpitchoutput = makeoutputvector[pitch3];


opticrolloutput = makeoutputvector[roll3];


opticniyawoutput := makeoutputvector[yaw3].e2ni;


opticnipitchoutput := makeoutputvector[pitch3].e2ni;


opticnirolloutput := makeoutputvector[roll3].e2ni;


doplots = True;


doplots::usage = "doplots is a switch that enables plotting when set to True";


MyOpenCylinder5::usage = "MyOpenCylinder5[(r:1, {h1:1,h2:1}, (n:20r))] is a list of n polygons approximating an open cylinder \
centered around the z-axis with radius r from z=h1 to h2."; 
MyCuboid::usage = "MyCuboid is like Cuboid[] but works with RotateShape, etc"; 
MyOpenCuboid::usage = "MyOpenCuboid is like MyCuboid[] except that the faces on the +x side and -x sides are missing"; 


MyCuboid[{x1_, y1_, z1_}, {x2_, y2_, z2_}] := {Polygon[{{x2, y1, z1}, {x2, y2, z1}, {x2, y2, z2}, {x2, y1, z2}}], 
	Polygon[{{x1, y1, z1}, {x1, y1, z2}, {x1, y2, z2}, {x1, y2, z1}}], 
	Polygon[{{x1, y2, z1}, {x1, y2, z2}, {x2, y2, z2}, {x2, y2, z1}}], 
	Polygon[{{x1, y1, z1}, {x2, y1, z1}, {x2, y1, z2}, {x1, y1, z2}}], 
	Polygon[{{x1, y1, z2}, {x2, y1, z2}, {x2, y2, z2}, {x1, y2, z2}}], 
	Polygon[{{x1, y1, z1}, {x1, y2, z1}, {x2, y2, z1}, {x2, y1, z1}}]};
	
MyOpenCuboid[{x1_, y1_, z1_}, {x2_, y2_, z2_}] := {
	Polygon[{{x1, y2, z1}, {x1, y2, z2}, {x2, y2, z2}, {x2, y2, z1}}], 
	Polygon[{{x1, y1, z1}, {x2, y1, z1}, {x2, y1, z2}, {x1, y1, z2}}], 
	Polygon[{{x1, y1, z2}, {x2, y1, z2}, {x2, y2, z2}, {x1, y2, z2}}], 
	Polygon[{{x1, y1, z1}, {x1, y2, z1}, {x2, y2, z1}, {x2, y1, z1}}]}
	
If[$VersionNumber < 6., 
	RotateShapeXYZ[shape_, yaw_, pitch_, roll_] := Block[
		{rotmat = RotationMatrixXYZBS[N[yaw], N[pitch], N[roll]]}, 
		shape/. {
			poly:Polygon[_] :> Map[rotmat . #1 & , poly, {2}], 
			line:Line[_] :> Map[rotmat . #1 & , line, {2}], 
			point:Point[_] :> Map[rotmat . #1 & , point, {1}]
		}
	]; 
       
    MyOpenCylinder5[r_, {h1_, h2_}, n_Integer] := 
    Graphics`Shapes`Private`MakeShape[
    	Block[
    		{rcphi, rsphi}, 
    		Table[
    			rcphi = N[r*Cos[2*Pi*(i/n)]]; 
    			rsphi = N[r*Sin[2*Pi*(i/n)]]; 
				{{rcphi, rsphi, h2}, {rcphi, rsphi, h1}}, 
				{i, n}
			]
		], 
		0, 1
	] /; n > 2; 
         
    MyOpenCylinder5[r_:1, {h1_:1, h2_:1}] := 
    MyOpenCylinder5[r, {h1, h2}, Round[20*r]]
];
    
MyOpenCylinder[r_, {h1_, h2_}, n_Integer] := Table[
	Polygon[{
		{r*Cos[2*Pi*(i/n)], r*Sin[2*Pi*(i/n)], h1}, 
		{r*Cos[2*Pi*(i/n)], r*Sin[2*Pi*(i/n)], h2}, 
		{r*Cos[2*Pi*((i + 1)/n)], r*Sin[2*Pi*((i + 1)/n)], h2}, 
		{r*Cos[2*Pi*((i + 1)/n)], r*Sin[2*Pi*((i + 1)/n)], h1}
	}], 
	{i, n}
] /; n > 2; 
	
MyOpenCylinder[r_:1, {h1_:1, h2_:1}] := MyOpenCylinder[r, {h1, h2}, Round[20*r]]


maxx:=Max[nx,ux,ix,tx];
maxy:=Max[ny,uy,ir,tr,nn0,nn1,n0,n1,n2,n3,n4,n5];


ztop:=z00/.constval;
zbottom:=z00-tln-dm-dn-tl1-d0-d1-tl2-d2-d3-tl3-d4-tr/.constval;


If[True,
	supportpoints[sub_] := {
		Graphics3D[Point[support/.constval/.sub]]
	};
	referencemarkers := {
		Graphics3D[Point[{+maxx,+maxy, ztop}/.constval]],
		Graphics3D[Point[{+maxx,-maxy, ztop}/.constval]],
		Graphics3D[Point[{-maxx,+maxy, ztop}/.constval]],
		Graphics3D[Point[{-maxx,-maxy, ztop}/.constval]],
		Graphics3D[Point[{+maxx,+maxy, zbottom}/.constval]],
		Graphics3D[Point[{+maxx,-maxy, zbottom}/.constval]],
		Graphics3D[Point[{-maxx,+maxy, zbottom}/.constval]],
		Graphics3D[Point[{-maxx,-maxy, zbottom}/.constval]]
	};
];


If[True,
	wires[sub_] := Table[
		Graphics3D[
			Line[
				{
					b2s[wirelist[[i,w$obj1]],wirelist[[i,w$pos1]]],
					b2s[wirelist[[i,w$obj2]],wirelist[[i,w$pos2]]]
				}/.constval/.sub
			]
		],
		{i,1,10}
	]
];



If[True,
	fibres[sub_] := Table[
		Graphics3D[
			Line[
				{
					b2s[wirelist[[i,w$obj1]],wirelist[[i,w$pos1]]],
					b2s[wirelist[[i,w$obj2]],wirelist[[i,w$pos2]]]
				}/.constval/.sub
			]
		],
		{i,11,22}
	]
];



If[$VersionNumber<6.,
	bladeULoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			0, 0, 0
		],
		bladeUL[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeULoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[		
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						0, {1,0,0}, {0,0,0}
					],
					0, {0,1,0}, {0,0,0}
				],
				0, {0,0,1}, {0,0,0}
			],
			bladeUL[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	bladeURoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			0, 0, 0
		],
		bladeUR[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeURoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						0, {1,0,0}, {0,0,0}
					],
					0, {0,1,0}, {0,0,0}
				],
				0, {0,0,1}, {0,0,0}
			],
			bladeUR[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	massNoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyOpenCuboid[
					{-nx/2,-ny/2,-nz/2},{nx/2,ny/2,nz/2}
				]
			],
			yaw0, pitch0, roll0
		],
		{x0, y0, z0}
	]/.constval/.sub,
(* else v6+ *)
	massNoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						MyOpenCuboid[
							{-nx/2,-ny/2,-nz/2},{nx/2,ny/2,nz/2}
						],
						roll0, {1,0,0}, {0,0,0}
					],
					pitch0, {0,1,0}, {0,0,0}
				],
				yaw0, {0,0,1}, {0,0,0}
			],
			{x0, y0, z0}
		]
	]/.constval/.sub


];


If[$VersionNumber<6.,
	bladeILoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			yaw0, pitch0, roll0
		],
		bladeIL[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeILoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						roll0, {1,0,0}, {0,0,0}
					],
					pitch0, {0,1,0}, {0,0,0}
				],
				yaw0, {0,0,1}, {0,0,0}
			],
			bladeIL[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	bladeIRoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			yaw0, pitch0, roll0
		],
		bladeIR[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeIRoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						roll0, {1,0,0}, {0,0,0}
					],
					pitch0, {0,1,0}, {0,0,0}
				],
				yaw0, {0,0,1}, {0,0,0}
			],
			bladeIR[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	massUoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyOpenCuboid[
					{-ux/2,-uy/2,-uz/2},{ux/2,uy/2,uz/2}
				]
			],
			yaw1, pitch1, roll1
		],
		{x1, y1, z1}
	]/.constval/.sub,
(* else v6+ *)
	massUoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						MyOpenCuboid[
							{-ux/2,-uy/2,-uz/2},{ux/2,uy/2,uz/2}
						],
						roll1, {1,0,0}, {0,0,0}
					],
					pitch1, {0,1,0}, {0,0,0}
				],
				yaw1, {0,0,1}, {0,0,0}
			],
			massU[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	bladeLLoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			yaw1, pitch1, roll1
		],
		bladeLL[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeLLoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						roll1, {1,0,0}, {0,0,0}
					],
					pitch1, {0,1,0}, {0,0,0}
				],
				yaw1, {0,0,1}, {0,0,0}
			],
			bladeLL[[{1,2,3}]]
		]
	]/.constval/.sub

];


If[$VersionNumber<6.,
	bladeLRoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			Graphics3D[
				MyCuboid[
					{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
				]
			],
			yaw1, pitch1, roll1
		],
		bladeLR[[{1,2,3}]]
	]/.constval/.sub,
(* else v6+ *)
	bladeLRoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Cuboid[
							{-btx/2,-bty/2,-btz/2},{btx/2,bty/2,btz/2}
						],
						roll1, {1,0,0}, {0,0,0}
					],
					pitch1, {0,1,0}, {0,0,0}
				],
				yaw1, {0,0,1}, {0,0,0}
			],
			bladeLR[[{1,2,3}]]
		]
	]/.constval/.sub

];


If[$VersionNumber<6.,
	massIoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			RotateShapeXYZ[
				Graphics3D[
					MyOpenCylinder5[
						ir,{-ix/2,ix/2},20
					]
				],
				0, Pi/2, 0
			],
			yaw2, pitch2, roll2
		],
		{x2, y2, z2}
	]/.constval/.sub,
(* else v6+ *)
	massIoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Rotate[
							MyOpenCylinder[
								ir,{-ix/2,ix/2},20
							],
							Pi/2, {0,1,0}, {0,0,0}
						],
						roll2, {1,0,0}, {0,0,0}
					],
					pitch2, {0,1,0}, {0,0,0}
				],
				yaw2, {0,0,1}, {0,0,0}
			],
			massI[[{1,2,3}]]
		]
	]/.constval/.sub
];


If[$VersionNumber<6.,
	opticoutline[sub_] := TranslateShape[
		RotateShapeXYZ[
			RotateShapeXYZ[
				Graphics3D[
					MyOpenCylinder5[
						tr,{-tx/2,tx/2},20
					]
				],
				0, Pi/2, 0
			],
			yaw3, pitch3, roll3
		],
		{x3, y3, z3}
	]/.constval/.sub,
(* else v6+ *)
	opticoutline[sub_] := Graphics3D[
		Translate[
			Rotate[
				Rotate[
					Rotate[
						Rotate[
							MyOpenCylinder[
								tr,{-tx/2,tx/2},20
							],
							Pi/2, {0,1,0}, {0,0,0}
						],
						roll3, {1,0,0}, {0,0,0}
					],
					pitch3, {0,1,0}, {0,0,0}
				],
				yaw3, {0,0,1}, {0,0,0}
			],
			optic[[{1,2,3}]]
		]
	]/.constval/.sub
];


eigenplot::usage = "eigenplot[e, f, {x, y, z},fm] makes a plot of the eigenvector e, scaled by a factor f, with viewpoint {x,y,z} using float matrix fm to calculate the values of the floats.";


eigenplot[e_, ff_, {x_, y_, z_},fm_] := If[
	doplots,
	Block[
		{s=tosub[ff e, fm]},
		Show[
			referencemarkers,
			wires[s],
			fibres[s],
			(*opticpoints[s],*)
			(*supportpoints[s],*)
			bladeULoutline[s],
			bladeURoutline[s],
			massNoutline[s],
			bladeILoutline[s],
			bladeIRoutline[s],
			massUoutline[s],
			bladeLLoutline[s],
			bladeLRoutline[s],
			massIoutline[s],
			opticoutline[s],
			ViewPoint->{x, y, z},
			PlotRange->{{-1.5 maxx,1.5 maxx},{-maxy,maxy},{zbottom-0.1,ztop}}/.constval
		]
	],
	Print["Plots switched off (doplots = False)"]
]


pad::usage = "pad[ev] takes an eigenvector and inserts dummy values where angle variables had been suppressed, so as to make even groups of six.";


pad[e_]:=Partition[e,6](*{
	Join[{Infinity,Infinity},e[[{1}]],{Infinity,Infinity,Infinity}],
	Join[{Infinity,Infinity},e[[{2}]],{Infinity,Infinity,Infinity}],
	e[[{3,4,5,6,7,8}]],
	Join[{Infinity,Infinity},e[[{9}]],{Infinity,Infinity,Infinity}],
	Join[{Infinity,Infinity},e[[{10}]],{Infinity,Infinity,Infinity}],
	e[[{11,12,13,14,15,16}]],
	Join[{Infinity,Infinity},e[[{17}]],{Infinity,Infinity,Infinity}],
	Join[{Infinity,Infinity},e[[{18}]],{Infinity,Infinity,Infinity}],
	e[[{19,20,21,22,23,24}]],
	e[[{25,26,27,28,29,30}]]
}*)


pretty::usage = "pretty[ev] prints an eigenvector in a pretty table format with headings.";


pretty[e_] := TableForm[Transpose[Join[{{"","Mass N","Mass U","Mass 2","optic"}},Transpose[Join[{{"x","y","z","yaw","pitch","roll"}},pad[e]]]]]] 


pretty[h_,e_] :=Chop[Join[{{"f","x","y","z","yaw","pitch","roll"}}, Transpose[Join[{h},Transpose[pad[e]]]]]]


oldvars::usage = "oldvars is like allvars except with the full 6 coordinates of each blade tip for comparability with the full model.";


prettyold[e_]:=TableForm[Transpose[Join[{{"","UL blade","UR blade","Mass N","IL blade","IR blade","Mass U","LL blade","LR blade","Mass 2","optic"}},Transpose[Join[{{"x","y","z","yaw","pitch","roll"}},Partition[e,6]]]]]]


prettyold::usage = "prettyold[ev] is the version of pretty[] from the full model for use with oldvars.";


prettyold[e_]:=TableForm[Transpose[Join[{{"","UL blade","UR blade","Mass N","IL blade","IR blade","Mass U","LL blade","LR blade","Mass 2","optic"}},Transpose[Join[{{"x","y","z","yaw","pitch","roll"}},Partition[e,6]]]]]]


longpitchQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	StringPosition[s,"pitch"]=={{1,5}}
	||StringPosition[s,"x"]=={{1,1}}
]

transrollQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	(
		StringPosition[s,"y"]=={{1,1}}
		&&StringPosition[s,"yaw"]=={}
	)
	||StringPosition[s,"roll"]=={{1,4}}
]

yawQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	StringPosition[s,"yaw"]=={{1,3}}
]

vertQ[e_] := Block[
	{s=ToString[important[e][[1]]]},
	StringPosition[s,"z"]=={{1,1}}
]
