% local damping functions for the quad pendulum model
% P Fritschel, 6 aug 2001
% standard local control added as option K Strain 28th Aug 2001
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                   %
%    eddy current damping model, proportional to    %
%    velocity up to ~150 Hz                         %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



veldamp = zpk([0],-1000,30000);  %gain included to represent appropriate eddy current coupling 
if damper == 1
    damping  = veldamp;   % velocity damping
    else if damper == 2
    damping  = local4ss(1);   % standard adapted GEO active damping, normalized to 'unit' gain
    end
end
% start simple: all damping paths have same damping function

ldamp = damping;
pdamp = damping;
vdamp = damping;
ydamp = damping;
tdamp = damping;
rdamp = damping;