defaultvalues = {g -> 9.81, nx -> 0.13, ny -> 0.5, nz -> 0.084, 
     denn -> 4000., mn -> 17.6246, Inx -> 0.164, Iny -> 0.0483, 
     Inz -> 0.1594, ux -> 0.13, uy -> 0.5, uz -> 0.084, den1 -> 4000, 
     m1 -> 16.3747, I1x -> 0.1302, I1y -> 0.046, I1z -> 0.1255, ix -> 0.12, 
     ir -> 0.14, den2 -> 2200., m2 -> 16.24, I2x -> 0.188, I2y -> 0.11393, 
     I2z -> 0.113, tx -> 0.12, tr -> 0.14, den3 -> 4000., m3 -> 28.41, 
     I3x -> 0.2818, I3y -> 0.1664, I3z -> 0.1664, ln -> 0.54, l1 -> 0.304, 
     l2 -> 0.302, l3 -> 0.6, nwn -> 2, nw1 -> 4, nw2 -> 4, nw3 -> 4, 
     rn -> 0.00039999999999999996, r1 -> 0.00028, r2 -> 0.00028, 
     r3n -> 0.00017999999999999998, r3m -> 0.00017999999999999998, 
     Yn -> 1.65*^11, Y1 -> 1.65*^11, Y2 -> 1.65*^11, Y3 -> 1.65*^11, 
     bladealpha -> 1.58, bladeY -> 186000000000, hmin -> 0.001, 
     hinc -> 0.0005, hsteps -> 12, wmin -> 0.03, wsteps -> 18, 
     mntb -> (m1 + m2 + m3 + mn)/2, mnb -> mn/2, smaxn -> 900000000, 
     lmaxn -> 0.55, wmaxn -> 0.1, ufcn -> opt[mnb, mntb, smaxn, lmaxn, wmaxn, 
       g, bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 1], 
     lnb -> opt[mnb, mntb, smaxn, lmaxn, wmaxn, g, bladealpha, bladeY, hmin, 
       hinc, hsteps, wmin, wsteps, 2], anb -> opt[mnb, mntb, smaxn, lmaxn, 
       wmaxn, g, bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 3], 
     hnb -> opt[mnb, mntb, smaxn, lmaxn, wmaxn, g, bladealpha, bladeY, hmin, 
       hinc, hsteps, wmin, wsteps, 4], stn -> opt[mnb, mntb, smaxn, lmaxn, 
       wmaxn, g, bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 5], 
     intmoden -> (3764.75*hnb)/lnb^2, m1tb -> (m1 + m2 + m3)/2, m1b -> m1/2, 
     smax1 -> 8.5*^8, lmax1 -> 0.42, wmax1 -> 0.055, 
     ufc1 -> opt[m1b, m1tb, smax1, lmax1, wmax1, g, bladealpha, bladeY, hmin, 
       hinc, hsteps, wmin, wsteps, 1], l1b -> opt[m1b, m1tb, smax1, lmax1, 
       wmax1, g, bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 2], 
     a1b -> opt[m1b, m1tb, smax1, lmax1, wmax1, g, bladealpha, bladeY, hmin, 
       hinc, hsteps, wmin, wsteps, 3], h1b -> opt[m1b, m1tb, smax1, lmax1, 
       wmax1, g, bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 4], 
     st1 -> opt[m1b, m1tb, smax1, lmax1, wmax1, g, bladealpha, bladeY, hmin, 
       hinc, hsteps, wmin, wsteps, 5], intmode1 -> (3764.75*h1b)/l1b^2, 
     m2tb -> (m2 + m3)/2, m2b -> m2/2, smax2 -> 8.*^8, lmax2 -> 0.34, 
     wmax2 -> 0.044, ufc2 -> opt[m2b, m2tb, smax2, lmax2, wmax2, g, 
       bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 1], 
     l2b -> opt[m2b, m2tb, smax2, lmax2, wmax2, g, bladealpha, bladeY, hmin, 
       hinc, hsteps, wmin, wsteps, 2], a2b -> opt[m2b, m2tb, smax2, lmax2, 
       wmax2, g, bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 3], 
     h2b -> opt[m2b, m2tb, smax2, lmax2, wmax2, g, bladealpha, bladeY, hmin, 
       hinc, hsteps, wmin, wsteps, 4], st2 -> opt[m2b, m2tb, smax2, lmax2, 
       wmax2, g, bladealpha, bladeY, hmin, hinc, hsteps, wmin, wsteps, 5], 
     intmode2 -> (3764.75*h2b)/l2b^2, dees -> 0.001, dm -> 0.001, 
     dn -> 0.001, d0 -> 0.001, d1 -> 0.001, d2 -> -0.001, d3 -> 0.008, 
     d4 -> 0.001, twistlength -> 0., d3tr -> d3 - twistlength, 
     d4tr -> d4 - twistlength, sn -> 0., su -> 0.0025, si -> 0.0025, 
     sl -> 0.007, nn0 -> 0.25, nn1 -> 0.05, n0 -> 0.2, n1 -> 0.07, 
     n2 -> 0.12, n3 -> 0.0065 + ir, n4 -> 0.0015 + tr, n5 -> 0.0015 + tr, 
     tln -> dm + Sqrt[-(nn0 - nn1)^2 + sln^2], 
     tl1 -> d0 + dn + Sqrt[-(n0 - n1)^2 + sl1^2], 
     tl2 -> d1 + d2 + Sqrt[-(n2 - n3)^2 + sl2^2], 
     tl3 -> d3 + d4 + Sqrt[-(n4 - n5)^2 + sl3^2], 
     ltotal -> tl1 + tl2 + tl3 + tln, bd -> 0., leverpitch -> 0.06, 
     leverroll -> 0.09, leveryaw -> 0.09, gainf -> 1, gain -> 6/gainf, 
     gainvpr -> gain, gainlty -> gain, gainpitch -> gainvpr, 
     gainroll -> 0.4666666666666666*gainvpr, gainyaw -> 1.*gainlty, 
     gainvertical -> 0.6666666666666666*gainvpr, gainlongitudinal -> gainlty, 
     gaintransverse -> 2.*gainlty, unstretched -> False, vertblades -> True, 
     matlabcompat -> False, uln -> If[unstretched, ln, 
       ln - ((mn + m1 + m2 + m3)*g)/(nwn*kwn*Cos[ArcSin[(nn0 - nn1)/ln]])], 
     ul1 -> If[unstretched, l1, l1 - ((m1 + m2 + m3)*g)/
         (nw1*kw1*Cos[ArcSin[(n0 - n1)/l1]])], 
     ul2 -> If[unstretched, l2, l2 - ((m2 + m3)*g)/
         (nw2*kw2*Cos[ArcSin[(n2 - n3)/l2]])], 
     ul3 -> If[unstretched, l3, 
       l3 - (m3*g)/(nw3*kw3*Cos[ArcSin[(n4 - n5)/l3]])], 
     sln -> If[unstretched, ln + ((mn + m1 + m2 + m3)*g)/
         (nwn*kwn*Cos[ArcTan[(nn0 - nn1)/ln]]), ln], 
     sl1 -> If[unstretched, l1 + ((m1 + m2 + m3)*g)/
         (nw1*kw1*Cos[ArcTan[(n0 - n1)/l1]]), l1], 
     sl2 -> If[unstretched, l2 + ((m2 + m3)*g)/(nw2*kw2*
          Cos[ArcTan[(n2 - n3)/l2]]), l2], 
     sl3 -> If[unstretched, l3 + (m3*g)/(nw3*kw3*Cos[ArcTan[(n4 - n5)/l3]]), 
       l3], sin -> (-nn0 + nn1)/sln, si1 -> (-n0 + n1)/sl1, 
     si2 -> (-n2 + n3)/sl2, si3 -> (-n4 + n5)/sl3, 
     cn -> Sqrt[-(-nn0 + nn1)^2 + sln^2]/sln, 
     c1 -> Sqrt[-(-n0 + n1)^2 + sl1^2]/sl1, 
     c2 -> Sqrt[-(-n2 + n3)^2 + sl2^2]/sl2, 
     c3 -> Sqrt[-(-n4 + n5)^2 + sl3^2]/sl3, pitchbul -> 0, pitchbur -> 0, 
     pitchbil -> 0, pitchbir -> 0, pitchbll -> 0, pitchblr -> 0, 
     rollbul -> If[vertblades, 0, -ArcSin[sin]], 
     rollbur -> If[vertblades, 0, ArcSin[sin]], 
     rollbil -> If[vertblades, 0, -ArcSin[si1]], 
     rollbir -> If[vertblades, 0, ArcSin[si1]], 
     rollbll -> If[vertblades, 0, -ArcSin[si2]], 
     rollblr -> If[vertblades, 0, ArcSin[si2]], An -> 3.141592653589793*rn^2, 
     A1 -> 3.141592653589793*r1^2, A2 -> 3.141592653589793*r2^2, 
     A3n -> 3.141592653589793*r3n^2, A3m -> 3.141592653589793*r3m^2, 
     nf -> 0.1, kwn -> (An*Yn)/ln, kw1 -> (A1*Y1)/l1, kw2 -> (A2*Y2)/l2, 
     kw3 -> (kw3m^(-1) + 2/kw3n)^(-1), kw3n -> (A3n*Y3)/(l3*nf), 
     kw3m -> (A3m*Y3)/(l3*(1 - 2*nf)), kbuz -> 39.47841760435743*mnb*ufcn^2, 
     kbiz -> 39.47841760435743*m1b*ufc1^2, 
     kblz -> 39.47841760435743*m2b*ufc2^2, kbux -> 10000*kbuz, 
     kbix -> 10000*kbiz, kblx -> 10000*kblz, 
     bdu -> (g*(m1/2 + m2/2 + m3/2 + mn/2)*If[vertblades, 1, 1/cn])/kbuz, 
     bdi -> (g*(m1/2 + m2/2 + m3/2)*If[vertblades, 1, 1/c1])/kbiz, 
     bdl -> (g*(m2/2 + m3/2)*If[vertblades, 1, 1/c2])/kblz, Inxy -> 0, 
     Inyz -> 0, Inzx -> 0, COM0x -> 0, COM0y -> 0, COM0z -> 0, FRP0x -> 0, 
     FRP0y -> 0, FRP0z -> 0, I1xy -> 0, I1yz -> 0, I1zx -> 0, COM1x -> 0, 
     COM1y -> 0, COM1z -> 0, FRP1x -> 0, FRP1y -> 0, FRP1z -> 0, I2xy -> 0, 
     I2yz -> 0, I2zx -> 0, COM2x -> 0, COM2y -> 0, COM2z -> 0, FRP2x -> 0, 
     FRP2y -> 0, FRP2z -> 0, I3xy -> 0, I3yz -> 0, I3zx -> 0, COM3x -> 0, 
     COM3y -> 0, COM3z -> 0, FRP3x -> 0, FRP3y -> 0, FRP3z -> 0, btx -> 0.03, 
     bty -> 0.03, btz -> 0.03, Mn1 -> 0.7853981633974483*rn^4, 
     Mn2 -> 0.7853981633974483*rn^4, M11 -> 0.7853981633974483*r1^4, 
     M12 -> 0.7853981633974483*r1^4, M21 -> 0.7853981633974483*r2^4, 
     M22 -> 0.7853981633974483*r2^4, M31 -> 0.7853981633974483*r3n^4, 
     M32 -> 0.7853981633974483*r3n^4, temperature -> 290., 
     boltzmann -> 1.380658*^-23, alphasilica -> 5.1*^-7, 
     betasilica -> 0.00015, rhosilica -> 2200., Csilica -> 772., 
     Ksilica -> 1.38, Ysilica -> 7.*^10, phisilica -> 2.*^-8, 
     phissilica -> 3.2999999999999996*^-11, rhosteel -> 7800., 
     Csteel -> 486., Ksteel -> 49., Ysteel -> 1.65*^11, 
     alphasteel -> 0.000012, betasteel -> -0.00025, phisteel -> 0.0002, 
     rhomarag -> 7800., Cmarag -> 460., Kmarag -> 20., Ymarag -> 1.65*^11, 
     alphamarag -> 0.000011, betamarag -> 0., phimarag -> 0.0001, 
     tmU -> 0.0045, tmI -> 0.0055, tmL -> 0.005, magicnumber -> 0.0732, 
     deltabladeU -> (alphamarag^2*temperature*Ymarag)/(Cmarag*rhomarag), 
     deltabladeI -> (alphamarag^2*temperature*Ymarag)/(Cmarag*rhomarag), 
     deltabladeL -> (alphamarag^2*temperature*Ymarag)/(Cmarag*rhomarag), 
     deltawireU -> (temperature*(alphasteel - (0.3183098861837907*betasteel*g*
            (m1 + m2 + m3 + mn))/(nwn*rn^2*Ysteel))^2*Ysteel)/
       (Csteel*rhosteel), deltawireI -> 
      (temperature*(alphasteel - (0.3183098861837907*betasteel*g*
            (m1 + m2 + m3))/(nw1*r1^2*Ysteel))^2*Ysteel)/(Csteel*rhosteel), 
     deltawireL -> (temperature*(alphasteel - (0.3183098861837907*betasteel*g*
            (m2 + m3))/(nw2*r2^2*Ysteel))^2*Ysteel)/(Csteel*rhosteel), 
     deltafibre -> (temperature*(alphasteel - (0.3183098861837907*betasteel*g*
            m3)/(nw3*r3n^2*Ysteel))^2*Ysteel)/(Csteel*rhosteel), 
     taubladeU -> (0.10132118364233778*Cmarag*rhomarag*tmU^2)/Kmarag, 
     taubladeI -> (0.10132118364233778*Cmarag*rhomarag*tmI^2)/Kmarag, 
     taubladeL -> (0.10132118364233778*Cmarag*rhomarag*tmL^2)/Kmarag, 
     tauwireU -> (4*Csteel*magicnumber*rhosteel*rn^2)/Ksteel, 
     tauwireI -> (4*Csteel*magicnumber*r1^2*rhosteel)/Ksteel, 
     tauwireL -> (4*Csteel*magicnumber*r2^2*rhosteel)/Ksteel, 
     taufibre -> (4*Csteel*magicnumber*r3n^2*rhosteel)/Ksteel, 
     damping[imag, bladeUtype] -> 
      (phimarag + (deltabladeU*(2*N[Pi]*#1*taubladeU))/
         (1 + (2*N[Pi]*#1*taubladeU)^2) & ), damping[imag, bladeItype] -> 
      (phimarag + (deltabladeI*(2*N[Pi]*#1*taubladeI))/
         (1 + (2*N[Pi]*#1*taubladeI)^2) & ), damping[imag, bladeLtype] -> 
      (phimarag + (deltabladeL*(2*N[Pi]*#1*taubladeL))/
         (1 + (2*N[Pi]*#1*taubladeL)^2) & ), damping[imag, wireUtype] -> 
      (phisteel & ), damping[imag, wireItype] -> (phisteel & ), 
     damping[imag, wireLtype] -> (phisteel & ), damping[imag, wireUatype] -> 
      (phisteel + (deltawireU*(2*N[Pi]*#1*tauwireU))/
         (1 + (2*N[Pi]*#1*tauwireU)^2) & ), damping[imag, wireIatype] -> 
      (phisteel + (deltawireI*(2*N[Pi]*#1*tauwireI))/
         (1 + (2*N[Pi]*#1*tauwireI)^2) & ), damping[imag, wireLatype] -> 
      (phisteel + (deltawireL*(2*N[Pi]*#1*tauwireL))/
         (1 + (2*N[Pi]*#1*tauwireL)^2) & ), damping[imag, fibretype] -> 
      (phisteel & ), damping[imag, fibreatype] -> 
      (phisteel + (deltafibre*(2*N[Pi]*#1*taufibre))/
         (1 + (2*N[Pi]*#1*taufibre)^2) & ), x00 -> 0, y00 -> 0, z00 -> 0, 
     yaw00 -> 0, pitch00 -> 0, roll00 -> 0, kconx0 -> 0, kcony0 -> 0, 
     kconz0 -> 0, kconyaw0 -> 0, kconpitch0 -> 0, kconroll0 -> 0, 
     kconx1 -> 0, kcony1 -> 0, kconz1 -> 0, kconyaw1 -> 0, kconpitch1 -> 0, 
     kconroll1 -> 0, kconx2 -> 0, kcony2 -> 0, kconz2 -> 0, kconyaw2 -> 0, 
     kconpitch2 -> 0, kconroll2 -> 0, kconx3 -> 0, kcony3 -> 0, kconz3 -> 0, 
     kconyaw3 -> 0, kconpitch3 -> 0, kconroll3 -> 0}
 
defaultvalues /: defaultvalues::usage = "defaultvalues is part of the \
specification of the model. It should be a list of substitutions for all \
constants. Some of the values can be given symbolically in terms of other \
constants in the list, but there should be enough given numerically that the \
whole collection becomes numeric when Recurse[] is applied."
 
g /: g::usage = "g is local gravity."
 
nx /: nx::usage = "nx is x size of top mass (mass N)."
 
ny /: ny::usage = "ny is y size of top mass (mass N)."
 
nz /: nz::usage = "nz is z size of top mass (mass N)."
 
denn /: denn::usage = "denn is density of top mass (mass N)."
 
mn /: mn::usage = "mn is mass of top mass (mass N)."
 
Inx /: Inx::usage = "Inx is x-axis MOI of top mass (mass N)."
 
Iny /: Iny::usage = "Iny is y-axis MOI of top mass (mass N)."
 
Inz /: Inz::usage = "Inz is z-axis MOI of top mass (mass N)."
 
ux /: ux::usage = "ux is x size of second top mass (mass U)."
 
uy /: uy::usage = "uy is y size of second top mass (mass U)."
 
uz /: uz::usage = "uz is z size of second top mass (mass U)."
 
den1 /: den1::usage = "den1 is density of second top mass (mass U)."
 
m1 /: m1::usage = "m1 is mass of second top mass (mass U)."
 
I1x /: I1x::usage = "I1x is x-axis MOI of second top mass (mass U)."
 
I1y /: I1y::usage = "I1y is y-axis MOI of second top mass (mass U)."
 
I1z /: I1z::usage = "I1z is z-axis MOI of second top mass (mass U)."
 
ix /: ix::usage = "ix is thickness of intermediate mass (mass I)."
 
ir /: ir::usage = "iy is radius of intermediate mass (mass I)."
 
den2 /: den2::usage = "den2 is density of intermediate mass (mass I)."
 
m2 /: m2::usage = "m2 is mass of intermediate mass (mass I)."
 
I2x /: I2x::usage = "I2x is x-axis MOI of intermediate mass (mass I)."
 
I2y /: I2y::usage = "I2y is y-axis MOI of intermediate mass (mass I)."
 
I2z /: I2z::usage = "I2z is z-axis MOI of intermediate mass (mass I)."
 
tx /: tx::usage = "ux is thickness of optic."
 
tr /: tr::usage = "uy is radius of optic."
 
den3 /: den3::usage = "den3 is density of optic."
 
m3 /: m3::usage = "m3 is mass of optic."
 
I3x /: I3x::usage = "I3x is x-axis MOI of optic."
 
I3y /: I3y::usage = "I3y is y-axis MOI of optic."
 
I3z /: I3z::usage = "I3z is z-axis MOI of optic."
 
ln /: ln::usage = "ln is part of the specification of the model and \
represents the wire length from structure to top mass. It is interpreted as \
either a stretched length or an unstretched length depending on the value of \
the switch constant unstretched."
 
l1 /: l1::usage = "l1 is part of the specification of the model and \
represents the wire length from top mass to second top mass. It is \
interpreted as either a stretched length or an unstretched length depending \
on the value of the switch constant unstretched."
 
l2 /: l2::usage = "l2 is part of the specification of the model and \
represents the wire length from second top mass to intermediate mass. It is \
interpreted as either a stretched length or an unstretched length depending \
on the value of the switch constant unstretched."
 
l3 /: l3::usage = "l3 is part of the specification of the model and \
represents the wire (fibre) length from intermediate mass to optic. It is \
interpreted as either a stretched length or an unstretched length depending \
on the value of the switch constant unstretched."
 
nwn /: nwn::usage = "nwn is number of wires from structure to top mass."
 
nw1 /: nw1::usage = "nw1 is number of wires from top mass to second top mass."
 
nw2 /: nw2::usage = 
     "nw2 is number of wires from second top mass to intermediate mass."
 
nw3 /: nw3::usage = 
     "nw3 is number of wires (fibres) from intermediate mass to optic."
 
rn /: rn::usage = "rn is radius of wires from structure to top mass."
 
r1 /: r1::usage = "r1 is radius of wires from top mass to second top mass."
 
r2 /: r2::usage = 
     "r2 is radius of wires from second top mass to intermediate mass."
 
r3n /: r3n::usage = 
     "r3n is radius of wires (fibres) necks from intermediate mass to optic."
 
r3m /: r3m::usage = "r3n is radius of wires (fibres) midsections from \
intermediate mass to optic."
 
Yn /: Yn::usage = "Yn is Young's modulus of wires from structure to top mass."
 
Y1 /: Y1::usage = 
     "Y1 is Young's modulus of wires from top mass to second top mass."
 
Y2 /: Y2::usage = 
     "Y2 is Young's modulus of wires from second top mass to intermediate \
mass."
 
Y3 /: Y3::usage = 
     "Y3 is Young's modulus of wires (fibres) from intermediate mass to \
optic."
 
mntb /: mntb::usage = "mntb is design load on upper blades (on structure)."
 
mnb /: mnb::usage = "mntb is the \"uncoupled mass\" (its share of the mass \
only one stage below) for the upper blades (on structure)."
 
ufcn /: ufcn::usage = "ufcn is the \"uncoupled frequency\" (what they would \
vibrate at with only their \"uncoupled mass\", mnb) for the upper blades (on \
structure)."
 
opt[m_, mt_, smax_, lmax_, wmax_, outarg_Integer] := 
    Block[{g, alpha, ye, mtb, mb, index, h, jindex, a, s, d, f, stress, 
       fmin1, index1, fmin2, index2, flist, stresslist, ufc, lb, aindex, ab, 
       hindex, hb, st}, g = 9.81; alpha = 1.58; ye = 186*10^9; mtb = mt; 
       mb = m; lb = lmax; For[index = 1, index <= 12, index++, 
        h = 0.001 + index*0.0005; For[jndex = 1, jndex <= 18, jndex++, 
          a = 0.03 + ((wmax - 0.03)*jndex)/18; s = (6*mtb*g*lb)/(a*h^2); 
           d = (4*mtb*g*lb^2*alpha)/(ye*a*h^3); If[s < smax && d < N[Pi]/2, 
            f[index, jndex] = Sqrt[(ye*a*h^3)/(4*mb*lb^3*alpha)]/(2*N[Pi]); 
             stress[index, jndex] = s, f[index, jndex] = Infinity; 
             stress[index, jndex] = s; ]]]; flist = Table[f[index, jndex], 
         {index, 1, 12}, {jndex, 1, 18}]; stresslist = 
        Table[stress[index, jndex], {index, 1, 12}, {jndex, 1, 18}]; 
       {fmin1, index1} = MyMin[flist]; {fmin2, index2} = MyMin[fmin1]; 
       ufc = fmin2; aindex = index2; ab = 0.03 + ((wmax - 0.03)*aindex)/18; 
       hindex = index1[[aindex]]; hb = 0.001 + hindex*0.0005; 
       st = stresslist[[hindex,aindex]]; {ufc, lb, ab, hb, st}[[outarg]]] /; 
     NumericQ[m] && NumericQ[mt] && NumericQ[smax] && NumericQ[lmax] && 
      NumericQ[wmax]
 
opt[m_, mt_, smax_, lmax_, wmax_, g_, alpha_, ye_, hmin_, hinc_, hsteps_, 
     wmin_, wsteps_, outarg_Integer] := 
    Block[{mtb, mb, index, h, jindex, a, s, d, f, stress, fmin1, index1, 
       fmin2, index2, flist, stresslist, ufc, lb, aindex, ab, hindex, hb, 
       st}, mtb = mt; mb = m; lb = lmax; For[index = 1, index <= hsteps, 
        index++, h = hmin + index*hinc; For[jndex = 1, jndex <= wsteps, 
          jndex++, a = wmin + ((wmax - wmin)*jndex)/wsteps; 
           s = (6*mtb*g*lb)/(a*h^2); d = (4*mtb*g*lb^2*alpha)/(ye*a*h^3); 
           If[s < smax && d < N[Pi]/2, f[index, jndex] = 
              Sqrt[(ye*a*h^3)/(4*mb*lb^3*alpha)]/(2*N[Pi]); 
             stress[index, jndex] = s, f[index, jndex] = Infinity; 
             stress[index, jndex] = s; ]]]; flist = Table[f[index, jndex], 
         {index, 1, hsteps}, {jndex, 1, wsteps}]; 
       stresslist = Table[stress[index, jndex], {index, 1, hsteps}, 
         {jndex, 1, wsteps}]; {fmin1, index1} = MyMin[flist]; 
       {fmin2, index2} = MyMin[fmin1]; ufc = fmin2; aindex = index2; 
       ab = wmin + ((wmax - wmin)*aindex)/wsteps; hindex = index1[[aindex]]; 
       hb = hmin + hindex*hinc; st = stresslist[[hindex,aindex]]; 
       {ufc, lb, ab, hb, st}[[outarg]]] /; NumericQ[m] && NumericQ[mt] && 
      NumericQ[smax] && NumericQ[lmax] && NumericQ[wmax] && NumericQ[g] && 
      NumericQ[alpha] && NumericQ[ye] && NumericQ[hmin] && NumericQ[hinc] && 
      NumericQ[hsteps] && NumericQ[wmin] && NumericQ[wsteps]
 
opt /: opt::usage = "opt[m,mt,smax,lmax,wmax,outarg] or \
opt[m,mt,smax,lmax,wmin,wmax,wsteps,g,alpha,ye,hmin, hinc,hsteps,outarg] is a \
translation of the blade-optimizing function opt() from Ken Strain's Matlab \
model of the suspension. The first five arguments are as in the original \
Matlab function. The next three arguments if present are internal magic \
numbers that probably should have been input arguments originally. The last \
argument, outarg, selects one from among the several output arguments of the \
original. (Thus opt[] needs to be called several times to get all the output. \
This ugly hack was required to make it play well with the Recurse[] \
function.)"
 
MyMin[x_] := Block[{m = Min[x]}, {m, Position[x, m][[1,1]]}] /; 
     TensorRank[x] == 1
 
MyMin[x_] := Transpose[MyMin /@ Transpose[x]] /; TensorRank[x] == 2
 
MyMin /: MyMin::usage = "MyMin[x] is a rough equivalent of the Matlab min(x) \
function. It finds the minimum of a 1D array, or the minima of the columns of \
a 2D array."
 
lnb /: lnb::usage = "lnb is the length of the upper blades (on structure)."
 
anb /: anb::usage = 
     "anb is the width (at the base) of the upper blades (on structure)."
 
hnb /: hnb::usage = "hnb is the thickness of the upper blades (on structure)."
 
intmoden /: intmoden::usage = "intmoden is the frequency of the internal mode \
of the upper blades (on structure)."
 
m1tb /: m1tb::usage = 
     "m1tb is design load on intermediate blades (on top mass)."
 
m1b /: m1b::usage = "m1tb is the \"uncoupled mass\" (its share of the mass \
only one stage below) for the intermediate blades (on top mass)."
 
ufc1 /: ufc1::usage = "ufc1 is the \"uncoupled frequency\" (what they would \
vibrate at with only their \"uncoupled mass\", mn1) for the intermediate \
blades (on top mass)."
 
l1b /: l1b::usage = 
     "l1b is the length of the the intermediate blades (on top mass)."
 
a1b /: a1b::usage = "a1b is the width (at the base) of the the intermediate \
blades (on top mass)."
 
h1b /: h1b::usage = 
     "h1b is the thickness of the the intermediate blades (on top mass)."
 
intmode1 /: intmode1::usage = "intmode1 is the frequency of the internal mode \
of the intermediate blades (on top mass)."
 
m2tb /: m2tb::usage = 
     "m2tb is design load on lower blades (on second top mass)."
 
m2b /: m2b::usage = "m2tb is the \"uncoupled mass\" (its share of the mass \
only one stage below) for the lower blades (on second top mass)."
 
ufc2 /: ufc2::usage = "ufc2 is the \"uncoupled frequency\" (what they would \
vibrate at with only their \"uncoupled mass\", mn2) for the lower blades (on \
second top mass)."
 
l2b /: l2b::usage = 
     "l2b is the length of the lower blades (on second top mass)."
 
a2b /: a2b::usage = 
     "a2b is the width (at the base) of the lower blades (on second top \
mass)."
 
h2b /: h2b::usage = 
     "h2b is the thickness of the lower blades (on second top mass)."
 
intmode2 /: intmode2::usage = "intmode2 is the frequency of the internal mode \
of the lower blades (on second top mass)."
 
dees /: dees::usage = "dees is the default vertical distance from a wire \
attachment point to the COM."
 
dm /: dm::usage = "dm is the height of the wire attachment points above the \
COM of mass N for the wires leading down from the upper blade springs."
 
dn /: dn::usage = "dn is the height of the wire attachment points below the \
COM of mass N for the wires leading down to mass U."
 
d0 /: d0::usage = "d0 is the the height of the wire attachment points above \
the COM of mass U for the wires leading down from mass N."
 
d1 /: d1::usage = "d1 is the the height of the wire attachment points below \
the COM of mass U for the wires leading down to mass I."
 
d2 /: d2::usage = "d2 is the height of the wire attachment points above the \
COM of mass I for the wires leading down from the mass U."
 
d3 /: d3::usage = "d3 is the height of the wire attachment points below the \
COM of mass I for the wires leading down to the optic."
 
d4 /: d4::usage = "d4 is the the height of the wire attachment points above \
the COM of the optic for the wires leading down from mass I."
 
twistlength /: twistlength::usage = "twistlength was left over from Ken \
Strain's model. It's not used and it's anybody's guess what it is."
 
d3tr /: d3tr::usage = "d3tr was left over from Ken Strain's model. It's not \
used and it's anybody's guess what it is."
 
d4tr /: d4tr::usage = "d4tr was left over from Ken Strain's model. It's not \
used and it's anybody's guess what it is."
 
sn /: sn::usage = 
     "sn is x-direction separation of wires from structure to top mass."
 
su /: su::usage = 
     "su is x-direction separation of wires from top mass to second top \
mass."
 
si /: si::usage = "si is x-direction separation of wires from second top mass \
to intermediate mass."
 
sl /: sl::usage = "sl is x-direction separation of wires (fibres) from \
intermediate mass to optic."
 
nn0 /: nn0::usage = "nn0 is the y-direction separation of the wire attachment \
points on the structure for the wires leading down to mass N."
 
nn1 /: nn1::usage = "nn1 is the y-direction separation of the wire attachment \
points on mass N for the wires leading from the structure."
 
n0 /: n0::usage = "n0 is the y-direction separation of the wire attachment \
points on the upper blade springs (mass N) for the wires leading down to mass \
U."
 
n1 /: n1::usage = "n1 is the y-direction separation of the wire attachment \
points on mass U for the wires leading down from the upper blade springs \
(mass N)."
 
n2 /: n2::usage = "n2 is the y-direction separation of the wire attachment \
points on the intermediate blade springs (mass U) for the wires leading down \
to mass I."
 
n3 /: n3::usage = "n3 is the y-direction separation of the wire attachment \
points on mass I for the wires leading down from the intermediate blade \
springs (mass U)."
 
n4 /: n4::usage = "n4 is the y-direction separation of the wire attachment \
points on mass I for the wires leading down to the optic."
 
n5 /: n5::usage = "n5 is the y-direction separation of the wire attachment \
points on the optic for the wires leading down from mass I."
 
tln /: tln::usage = "tln is the vertical distance from structure attachment \
point to the COM of mass N."
 
sln /: sln::usage = "sln is stretched wire length from structure to top mass."
 
tl1 /: tl1::usage = 
     "tl1 is the vertical distance from the COM of mass N to the COM of mass \
U."
 
sl1 /: sl1::usage = 
     "sl1 is stretched wire length from top mass to second top mass."
 
tl2 /: tl2::usage = 
     "tl2 is the vertical distance from the COM of mass U to the COM of mass \
I."
 
sl2 /: sl2::usage = 
     "sl2 is stretched wire length from second top mass to intermediate \
mass."
 
tl3 /: tl3::usage = "tl3 is the vertical distance from the COM of mass I to \
the COM of the optic."
 
sl3 /: sl3::usage = 
     "sl3 is stretched wire (fibre) length from intermediate mass to optic."
 
ltotal /: ltotal::usage = "ltotal is the vertical distance from the structure \
attachement point to the COM of the optic."
 
bd /: bd::usage = "bd is a control system parameter which is currently not \
used in the Mathematica."
 
leverpitch /: leverpitch::usage = "leverpitch is a control system parameter \
which is currently not used in the Mathematica."
 
leverroll /: leverroll::usage = "leverroll is a control system parameter \
which is currently not used in the Mathematica."
 
leveryaw /: leveryaw::usage = "leveryaw is a control system parameter which \
is currently not used in the Mathematica."
 
gainf /: gainf::usage = "gainf is a control system parameter which is \
currently not used in the Mathematica."
 
gain /: gain::usage = "gain is a control system parameter which is currently \
not used in the Mathematica."
 
gainvpr /: gainvpr::usage = "gainvpr is a control system parameter which is \
currently not used in the Mathematica."
 
gainlty /: gainlty::usage = "gainlty is a control system parameter which is \
currently not used in the Mathematica."
 
gainpitch /: gainpitch::usage = "gainpitch is a control system parameter \
which is currently not used in the Mathematica."
 
gainroll /: gainroll::usage = "gainroll is a control system parameter which \
is currently not used in the Mathematica."
 
gainyaw /: gainyaw::usage = "gainyaw is a control system parameter which is \
currently not used in the Mathematica."
 
gainvertical /: gainvertical::usage = "gainvertical is a control system \
parameter which is currently not used in the Mathematica."
 
gainlongitudinal /: gainlongitudinal::usage = "gainlongitudinal is a control \
system parameter which is currently not used in the Mathematica."
 
gaintransverse /: gaintransverse::usage = "gaintransverse is a control system \
parameter which is currently not used in the Mathematica."
 
unstretched /: unstretched::usage = "unstretched is a switch that specifies \
whether ln, l1, l2 and l3 are to be interpreted as unstretched lengths or \
(approximate) stretched lengths."
 
uln /: uln::usage = 
     "uln is unstretched wire length from structure to top mass."
 
kwn /: kwn::usage = 
     "kwn is net longitudinal elasticity of wires from structure to top \
mass."
 
ul1 /: ul1::usage = 
     "ul1 is unstretched wire length from top mass to second top mass."
 
kw1 /: kw1::usage = "kw1 is net longitudinal elasticity of wires from top \
mass to second top mass."
 
ul2 /: ul2::usage = 
     "ul2 is unstretched wire length from second top mass to intermediate \
mass."
 
kw2 /: kw2::usage = "kw2 is net longitudinal elasticity of wires from second \
top mass to intermediate mass."
 
ul3 /: ul3::usage = 
     "ul3 is unstretched wire (fibre) length from intermediate mass to \
optic."
 
kw3 /: kw3::usage = "kw3 is net longitudinal elasticity of wires (fibres) \
from intermediate mass to optic."
 
sin /: sin::usage = "sin is sine of angle of top wires."
 
si1 /: si1::usage = "si1 is sine of angle of second top wires."
 
si2 /: si2::usage = "si2 is sine of angle of bottom wires."
 
si3 /: si3::usage = "is sine of angle of fibres."
 
cn /: cn::usage = "cn is cosine of angle of top wires."
 
c1 /: c1::usage = "c1 is cosine of angle of second top wires."
 
c2 /: c2::usage = "c2 is cosine of angle of bottom wires."
 
c3 /: c3::usage = "c3 is cosine of angle of fibres."
 
An /: An::usage = "An is effective average cross-sectional area of wires from \
structure to top mass for the purposes of calculating the longitudinal \
elasticity."
 
A1 /: A1::usage = "A1 is effective average cross-sectional area of wires from \
top mass to second top mass for the purposes of calculating the longitudinal \
elasticity."
 
A2 /: A2::usage = "A2 is effective average cross-sectional area of wires from \
second top mass to intermediate mass for the purposes of calculating the \
longitudinal elasticity."
 
A3n /: A3n::usage = "A3n is effective average cross-sectional area of wire \
(fibre) necks from intermediate mass to optic for the purposes of calculating \
the longitudinal elasticity."
 
A3m /: A3m::usage = "A3m is effective average cross-sectional area of wire \
(fibre) midsections from intermediate mass to optic for the purposes of \
calculating the longitudinal elasticity."
 
kw3m /: kw3m::usage = 
     "kw3m is net longitudinal elasticity of wire (fibre) midsection."
 
kw3n /: kw3n::usage = 
     "kw3n is net longitudinal elasticity of wire (fibre) neck."
 
kbuz /: kbuz::usage = 
     "kbuz is the net vertical elasticity of the upper blades (on \
structure)."
 
kbiz /: kbiz::usage = "kbiz is the net vertical elasticity of the the \
intermediate blades (on top mass)."
 
kblz /: kblz::usage = "kblz is the net vertical elasticity of the lower \
blades (on second top mass)."
 
kbux /: kbux::usage = 
     "kbux is the net transverse elasticity of the upper blades (on \
structure)."
 
kbix /: kbix::usage = "kbix is the net transverse elasticity of the the \
intermediate blades (on top mass)."
 
kblx /: kblx::usage = "kblx is the net transverse elasticity of the lower \
blades (on second top mass)."
 
bdu /: bdu::usage = "bdu is the effective pre-stretch distance of the upper \
blades (on structure)."
 
bdi /: bdi::usage = "bdi is the effective pre-stretch distance of the \
intermediate blades (on top mass)."
 
bdl /: bdl::usage = "bdl is the effective pre-stretch distance of the lower \
blades (on second top mass)."
 
btx /: btx::usage = 
     "btx is x-direction size of the box drawn to represent the blade tips."
 
bty /: bty::usage = 
     "bty is x-direction size of the box drawn to represent the blade tips."
 
btz /: btz::usage = 
     "btz is x-direction size of the box drawn to represent the blade tips."
 
Mn1 /: Mn1::usage = "Mn1 is the moment of area of wires from structure to top \
mass in direction \"1\"."
 
Mn2 /: Mn2::usage = "Mn2 is the moment of area of wires from structure to top \
mass in direction \"2\"."
 
M11 /: M11::usage = "M11 is the moment of area of wires from top mass to \
second top mass in direction \"1\"."
 
M12 /: M12::usage = "M12 is the moment of area of wires from top mass to \
second top mass in direction \"2\""
 
M21 /: M21::usage = "M21 is the moment of area of wires from second top mass \
to intermediate mass in direction \"1\""
 
M22 /: M22::usage = "M22 is the moment of area of wires from second top mass \
to intermediate mass in direction \"2\""
 
M31 /: M31::usage = "M31 is the moment of area of wire (fibre) necks from \
intermediate mass to optic in direction \"1\""
 
M32 /: M32::usage = "M32 is the moment of area of wire (fibre) necks from \
intermediate mass to optic in direction \"2\""
 
temperature /: temperature::usage = "temperature is, well, guess."
 
alphasilica /: alphasilica::usage = 
     "alphasilica is the coefficient of thermal expansion for silica."
 
betasilica /: betasilica::usage = 
     "betasilica is the temperature dependence of Young's modulus for \
silica."
 
rhosilica /: rhosilica::usage = "rhosilica is the density for silica."
 
Csilica /: Csilica::usage = "Csilica is the heat capacity for silica."
 
Ksilica /: Ksilica::usage = "Ksilica is the bulk modulus for silica."
 
Ysilica /: Ysilica::usage = "Ysilica is the Young's modulus for silica."
 
phisilica /: phisilica::usage = "phisilica is the bulk loss angle for silica."
 
phissilica /: phissilica::usage = 
     "phissilica is the surface loss angle (units of m) for silica."
 
rhosteel /: rhosteel::usage = "rhosteel is the density for C70 steel."
 
Csteel /: Csteel::usage = "Csteel is the heat capacity for C70 steel."
 
Ksteel /: Ksteel::usage = "Ksteel is the bulk modulus for C70 steel."
 
Ysteel /: Ysteel::usage = "Ysteel is the Young's modulus for C70 steel."
 
alphasteel /: alphasteel::usage = 
     "alphasteel is the coefficient of thermal expansion for C70 steel."
 
betasteel /: betasteel::usage = 
     "betasteel is the temperature dependence of Young's modulus for C70 \
steel."
 
phisteel /: phisteel::usage = "phisteel is the bulk loss angle for C70 steel."
 
rhomarag /: rhomarag::usage = "rhomarag is the density for maraging steel."
 
Cmarag /: Cmarag::usage = "Cmarag is the heat capacity for maraging steel."
 
Kmarag /: Kmarag::usage = "Kmarag is the bulk modulus for maraging steel."
 
Ymarag /: Ymarag::usage = "Ymarag is the Young's modulus for maraging steel."
 
alphamarag /: alphamarag::usage = 
     "alphamarag is the coefficient of thermal expansion for maraging steel."
 
betamarag /: betamarag::usage = "betamarag is the temperature dependence of \
Young's modulus for maraging steel."
 
phimarag /: phimarag::usage = 
     "phimarag is the bulk loss angle for maraging steel."
 
magicnumber /: magicnumber::usage = 
     "magicnumber is a geometrical factor for thermoelastic damping."
 
deltabladeU /: deltabladeU::usage = "deltabladeU is the thermoelastic damping \
parameter delta for the upper blades."
 
deltabladeI /: deltabladeI::usage = "deltabladeI is the thermoelastic damping \
parameter delta for the intermediate blades."
 
deltabladeL /: deltabladeL::usage = "deltabladeL is the thermoelastic damping \
parameter delta for the lower blades."
 
deltawireU /: deltawireU::usage = "deltawireU is the thermoelastic damping \
parameter delta for the wires from the structure to mass N."
 
deltawireI /: deltawireI::usage = "deltawireI is the thermoelastic damping \
parameter delta for the wires from from mass N to mass U."
 
deltawireL /: deltawireL::usage = "deltawireL is the thermoelastic damping \
parameter delta for the wires from mass U to mass I."
 
deltafibre /: deltafibre::usage = "deltafibre is the thermoelastic damping \
parameter delta for the wires from mass I to the optic."
 
taubladeU /: taubladeU::usage = 
     "taubladeU is the thermoelastic damping parameter tau for the upper \
blades."
 
taubladeI /: taubladeI::usage = "taubladeI is the thermoelastic damping \
parameter tau for the intermediate blades."
 
taubladeL /: taubladeL::usage = 
     "taubladeL is the thermoelastic damping parameter tau for the lower \
blades."
 
tauwireU /: tauwireU::usage = "tauwireU is the thermoelastic damping \
parameter tau for the wires from the structure to mass N."
 
tauwireI /: tauwireI::usage = "tauwireI is the thermoelastic damping \
parameter tau for the wires from mass N to mass U."
 
tauwireL /: tauwireL::usage = "tauwireL is the thermoelastic damping \
parameter tau for the wires from mass U to mass I."
 
taufibre /: taufibre::usage = "taufibre is the thermoelastic damping \
parameter tau for the wires from mass I to the optic."
 
damping /: damping::usage = "damping[imag,dampingtype] is a multiplier giving \
the frequency dependence of the imaginary (i.e., lossy) part of any potential \
terms tagged with symbol dampingtype. It should be a Mathematica pure \
function which accepts a value of f in Hz. It defaults to 0& but can be given \
a value via a substitution in defaultvalues. damping[real,dampingtype] is the \
corresponding real (i.e., elastic) multiplier. It defaults to 1&."
