startpos = {qzul -> 0, qxul -> 0, qzur -> 0, qxur -> 0, x0 -> -COM0x, 
     y0 -> 0, z0 -> -tln + z00, yaw0 -> 0, pitch0 -> 0, roll0 -> 0, 
     qzil -> 0, qxil -> 0, qzir -> 0, qxir -> 0, yawir -> 0, pitchir -> 0, 
     rollir -> 0, x1 -> -COM1x, y1 -> 0, z1 -> -tl1 - tln + z00, yaw1 -> 0, 
     pitch1 -> 0, roll1 -> 0, qzll -> 0, qxll -> 0, qzlr -> 0, qxlr -> 0, 
     x2 -> -COM2x, y2 -> 0, z2 -> -tl1 - tl2 - tln + z00, yaw2 -> 0, 
     pitch2 -> 0, roll2 -> 0, qqxulf -> -sl, qqyulf -> n5, 
     qqzulf -> -d3 - nf*sl3 - tl1 - tl2 - tln + z00, qqxurf -> -sl, 
     qqyurf -> -n5, qqzurf -> -d3 - nf*sl3 - tl1 - tl2 - tln + z00, 
     qqxulb -> sl, qqyulb -> n5, qqzulb -> -d3 - nf*sl3 - tl1 - tl2 - tln + 
       z00, qqxurb -> sl, qqyurb -> -n5, qqzurb -> -d3 - nf*sl3 - tl1 - tl2 - 
       tln + z00, qqxllf -> -sl, qqyllf -> n5, 
     qqzllf -> -d3 - (1 - nf)*sl3 - tl1 - tl2 - tln + z00, qqxlrf -> -sl, 
     qqylrf -> -n5, qqzlrf -> -d3 - (1 - nf)*sl3 - tl1 - tl2 - tln + z00, 
     qqxllb -> sl, qqyllb -> n5, qqzllb -> -d3 - (1 - nf)*sl3 - tl1 - tl2 - 
       tln + z00, qqxlrb -> sl, qqylrb -> -n5, 
     qqzlrb -> -d3 - (1 - nf)*sl3 - tl1 - tl2 - tln + z00, x3 -> -COM3x, 
     y3 -> 0, z3 -> -tl1 - tl2 - tl3 - tln + z00, yaw3 -> 0, pitch3 -> 0, 
     roll3 -> 0}
 
startpos /: startpos::usage = "startpos is part of the specification of the \
model. It should be a list of approximate values of all variables to be used \
as a starting point for minimizing the potential. The values can be given \
symbolically in terms of constants defined in the list defaultvalues."
 
tln /: tln::usage = "tln is the vertical distance from structure attachment \
point to the COM of mass N."
 
tl1 /: tl1::usage = 
     "tl1 is the vertical distance from the COM of mass N to the COM of mass \
U."
 
tl2 /: tl2::usage = 
     "tl2 is the vertical distance from the COM of mass U to the COM of mass \
I."
 
sl /: sl::usage = "sl is x-direction separation of wires (fibres) from \
intermediate mass to optic."
 
n5 /: n5::usage = "n5 is the y-direction separation of the wire attachment \
points on the optic for the wires leading down from mass I."
 
d3 /: d3::usage = "d3 is the height of the wire attachment points below the \
COM of mass I for the wires leading down to the optic."
 
sl3 /: sl3::usage = 
     "sl3 is stretched wire (fibre) length from intermediate mass to optic."
 
tl3 /: tl3::usage = "tl3 is the vertical distance from the COM of mass I to \
the COM of the optic."
