%function[pend] = quadopt
global pend
% Corresponds to case 20090819TM of Mathematica model mbquadlite2lateral
% For use with Matlab matrix elements ssmake4pv2eMB5.m/symbexport4lat.m of 8/8/08

% See equivalent Mathematica case for details of "derived" numbers
% "AFCP" = "as for controls prototype"

                         pend.stage2 = 1;
                         pend.ribbon = 0;
                              pend.g = 9.81;
                             pend.nx = 0.1300; % AFCP, T040214-01 (unused)
                             pend.ny = 0.5000; % AFCP, T040214-01 (unused)
                             pend.nz = 0.0840; % AFCP, T040214-01 (unused)
                           pend.denn = 4000; % AFCP, T040214-01 (unused)
                             pend.mn = 22.11; % T010103-05 
                            pend.Inx = 0.4558; % T010103-05 
                            pend.Iny = 0.0712; % T010103-05 
                            pend.Inz = 0.4547; % T010103-05 
                             pend.ux = 0.1300; % AFCP, T040214-01 (unused)
                             pend.uy = 0.5000; % AFCP, T040214-01 (unused)
                             pend.uz = 0.0840; % AFCP, T040214-01 (unused)
                           pend.den1 = 4000; % AFCP, T040214-01 (unused)
                             pend.m1 = 21.011; % T010103-05 
                            pend.I1x = 0.5174; % T010103-05 
                            pend.I1y = 0.0598; % T010103-05 
                            pend.I1z = 0.5205; % T010103-05 
                             pend.ix = 0.2000; % M050397-02/T010103-05 
                             pend.ir = 0.1700; % M050397-02/T010103-05 
                             pend.if = 0.0950; % M050397-02/T010103-05
                           pend.den2 = 2200; % T010103-05, Bench v4.1
                             pend.m2 = mflatnw(pend.den2,pend.ir,pend.ix,pend.if);
                            pend.I2x = Ixxflatnw(pend.den2,pend.ir,pend.ix,pend.if);
                            pend.I2y = Iyyflatnw(pend.den2,pend.ir,pend.ix,pend.if);
                            pend.I2z = Izzflatnw(pend.den2,pend.ir,pend.ix,pend.if);
                             pend.tx = 0.2000; % M050397-02/T010103-05 
                             pend.tr = 0.1700; % M050397-02/T010103-05
                             pend.tf = 0.0950; % M050397-02/T010103-05 
                           pend.den3 = 2200; % T010103-05, Bench 
                             pend.m3 = mflatnw(pend.den3,pend.tr,pend.tx,pend.tf);
                            pend.I3x = Ixxflatnw(pend.den3,pend.tr,pend.tx,pend.tf);
                            pend.I3y = Iyyflatnw(pend.den3,pend.tr,pend.tx,pend.tf);
                            pend.I3z = Izzflatnw(pend.den3,pend.tr,pend.tx,pend.tf);
                            pend.nwn = 2; 
                            pend.nw1 = 4; 
                            pend.nw2 = 4;
                            pend.nw3 = 4; 
                             pend.bd = 0.00; 
                             pend.rn = 5.200*10^-04; % AFCP, available size close to T010103-05; measured MB, 9/29/05 
                             pend.r1 = 3.5000*10^-04; % T010103-05 
                             pend.r2 = 3.1000*10^-04; % T010103-05 
                             pend.r3 = -1; %dummy
                            pend.r3n = 0.0008/2; % radius at neck
                            pend.r3m = 0.0004/2; % radius in midsection
                             pend.r3 = pend.r3n; % was r3m in Mathematica but needs to be like this for Matlab
                             pend.nl = 0.015; % neck length - specified directly instead of via nf (neck fraction) as in Mathematica
                             pend.Yn = 2.12000*10^+11; % measured, MB, 11/18/05, via IFOModel v4.1; cf. 2.2 in T010103-05
                             pend.Y1 = 2.12000*10^+11; % measured, MB, 11/18/05, via IFOModel v4.1; cf. 2.2 in T010103-05
                             pend.Y2 = 2.12000*10^+11; % measured, MB, 11/18/05, via IFOModel v4.1; cf. 2.2 in T010103-05
                             pend.Y3 = 7.2000*10^+10; % AH silica spec sheet, summary email by MB, 3/13/08
                    pend.twistlength = 0; 				% not used; T010103-05 
                           pend.d3tr = 1.0000*10^-03;	% not used; T010103-05 
                           pend.d4tr = 1.0000*10^-03;	% not used; T010103-05 
                             pend.sn = 0; 				% T010103-05 (AFCP) 
                             pend.su = 0.003;  % T010103-05 (AFCP)
                             pend.si = 0.003;  % T010103-05 (AFCP) 
                             pend.sl = 0.015;  % T010103-05 (AFCP) 
                            pend.nn0 = 0.250;  % T010103-05 (AFCP) 
                            pend.nn1 = 0.090;  % T010103-05 (AFCP) 
                             pend.n0 = 0.200;  % T010103-05 (AFCP) 
                             pend.n1 = 0.060;  % T010103-05 (AFCP) 
                             pend.n2 = 0.140;  % T010103-05 (AFCP) 
                             pend.n3 = 0.1762; % T010103-05 
                             pend.n4 = 0.1712; % T010103-05 
                             pend.n5 = 0.1712; % T010103-05 
                             pend.ln = -1; % dummy
                             pend.l1 = -1; % dummy
                             pend.l2 = -1; % dummy
                             pend.l3 = -1; % dummy
                             pend.dm = -1; % dummy
                             pend.dn = -1; % dummy
                             pend.d0 = -1; % dummy
                             pend.d1 = -1; % dummy
                             pend.d2 = -1; % dummy
                             pend.d3 = -1; % dummy
                             pend.d4 = -1; % dummy
                            pend.mn3 = pend.mn+pend.m1+pend.m2+pend.m3;
                            pend.m13 = pend.m1+pend.m2+pend.m3;
                            pend.m23 = pend.m2+pend.m3;
						pend.tlnspec = 0.416; % T010103-05
						pend.tl1spec = 0.277; % T010103-05
						pend.tl2spec = 0.341; % T010103-05
						pend.tl3spec = 0.602; % T010103-05
                            pend.kxn = 1.0*10^5;  % top blade lateral stiffness, AFCP, as for middle 
                            pend.kx1 = 1.0*10^5;  % middle blade lateral stiffness, AFCP, Justin 11/29/05 
                            pend.kx2 = 0.8*10^5;  % bottom blade lateral stiffness, AFCP, Ian 12/09/05 
                         pend.dmspec = 0.001; % effective d before wire flexure correction
                         pend.dnspec = 0.001; % effective d before wire and blade flexure correction
                         pend.d0spec = 0.001; % effective d before wire flexure correction
                         pend.d1spec = 0.001; % effective d before wire and blade flexure correction
                         pend.d2spec = 0.010; % larger d2 per M080134-00
                         pend.d3spec = 0.001; % effective d before wire flexure correction
                         pend.d4spec = 0.001; % effective d before wire flexure correction
                   [pend.ln pend.dm] = tldquadn(pend.tlnspec, pend.dmspec);
           [pend.l1 pend.dn pend.d0] = tldquad1(pend.tl1spec, pend.dnspec, pend.d0spec);
           [pend.l2 pend.d1 pend.d2] = tldquad2(pend.tl2spec, pend.d1spec, pend.d2spec);
           [pend.l3 pend.d3 pend.d4] = tldquad3(pend.tl3spec, pend.d3spec, pend.d4spec);
                                 ffn = 0.807; % AFCP, from Ian's data, 11/30/05 
                                 ff1 = 0.641; % AFCP, from Ian's data, 11/30/05 
                                 ff2 = 0.608; % AFCP, from Ian's data, 11/30/05 
                                 si0 = (pend.nn1-pend.nn0)/pend.ln;
                                 si1 = (pend.n1-pend.n0)/pend.l1;
                                 si2 = (pend.n3-pend.n2)/pend.l2;
                                 si3 = (pend.n5-pend.n4)/pend.l3;	
                                  cn = (pend.ln^2-(pend.nn1-pend.nn0)^2)^0.5/pend.ln;	%cos(omegan)
                                  c1 = (pend.l1^2-(pend.n1-pend.n0)^2)^0.5/pend.l1;	%cos(omega1)
                                  c2 = (pend.l2^2-(pend.n3-pend.n2)^2)^0.5/pend.l2;	%cos(omega2)
                                  c3 = (pend.l3^2-(pend.n5-pend.n4)^2)^0.5/pend.l3;	%cos(omega3)
                                kffn = 1 + ffn*tan(asin(si0));
                                kff1 = 1 + ff1*tan(asin(si1));
                                kff2 = 1 + ff2*tan(asin(si2));
							pend.kcn = 4*pi^2*(59/60)^2*61*kffn; % measured, T040229-12
							pend.kc1 = 4*pi^2*(70/60)^2*50*kff1; % measured, T040229-12
							pend.kc2 = 4*pi^2*(76/60)^2*39*kff2; % measured, T040229-12
                            
                           pend.kw3n = pend.Y3*pi*pend.r3n^2/pend.nl*pend.nw3/2; % defined per side rather than per wire as in Mathematica
                           pend.kw3m = pend.Y3*pi*pend.r3m^2/(pend.l3-2*pend.nl)*pend.nw3/2; % defined per side rather than per wire as in Mathematica
                            pend.kw3 = 1/(1/pend.kw3m+2/pend.kw3n); % defined per side rather than per wire as in Mathematica
                            
                            pend.tln = sqrt(pend.ln^2 - (pend.nn0-pend.nn1)^2) + pend.dm;
                            pend.tl1 = sqrt(pend.l1^2 - (pend.n0-pend.n1)^2) + pend.dn + pend.d0;
                            pend.tl2 = sqrt(pend.l2^2 - (pend.n2-pend.n3)^2) + pend.d1 + pend.d2;
                            pend.tl3 = sqrt(pend.l3^2 - (pend.n4-pend.n5)^2) + pend.d3 + pend.d4;
                            pend.Mn1 = (1/4)*pi*pend.rn^4;
                            pend.M11 = (1/4)*pi*pend.r1^4;
                            pend.M21 = (1/4)*pi*pend.r2^4;
                            if pend.ribbon
                                pend.M31 = pend.W3*pend.t3^3/12;
                                pend.M32 = pend.W3^3*pend.t3/12;
                            else
                                pend.M31 = (1/4)*pi*pend.r3^4;
                                pend.M32 = (1/4)*pi*pend.r3^4;
                            end
                          pend.flexn = sqrt(2*pend.Mn1*pend.Yn/pend.mn3/pend.g)*cn^(3/2);
                          pend.flex1 = sqrt(4*pend.M11*pend.Y1/pend.m13/pend.g)*c1^(3/2);
                          pend.flex2 = sqrt(4*pend.M21*pend.Y2/pend.m23/pend.g)*c2^(3/2);
                          pend.flex3 = sqrt(4*pend.M31*pend.Y3/pend.m3/pend.g)*c3^(3/2); % for long/pitch, yaw and vertical
 
% Output of quad_ref
%                      longpitch1: [0.4332 0.5193 0.9870 1.2331]
%                      longpitch2: [1.5674 2.0072 2.9454 3.4189]
%                             yaw: [0.5981 1.3452 2.4083 3.0462]
%                      transroll1: [0.4625 0.8615 1.0442 2.1240]
%                      transroll2: [2.6925 3.3254 5.0994 12.8743]
%                        vertical: [0.5815 2.3386 3.7604 9.0024]
% 

% Output of mathematica for comparison
% longpitchfreqs2 = {3.41893, 2.94539, 2.00727, 1.56866, 1.23394, 0.987195, 0.524882, 0.433341}
% 
% transrollfreqs2 = {12.8743, 5.09938, 3.3254, 2.69274, 2.124, 1.04438, 0.863443, 0.462476}
% 
% yawfreqs2 = {3.04627, 2.4084, 1.34564, 0.598138}
% 
% vertfreqs2 = {9.00227, 3.76036, 2.33857, 0.581511}
